# Read in AWIPS netCDF4 wind file and determine if there are any non-flagged values
# Run "python3 ${BIN_PATH}/check_analysis.py ${ANALYSIS_PATH}/filename
#
# Code developed by P. Reasor. Latest update: 03/03/2023
#
# Prints wind_status = 'failed'/'passed'

import sys
import netCDF4
import numpy as np

tdr_netcdf_file = sys.argv[1]
netcdf = netCDF4.Dataset(tdr_netcdf_file)

awips_list = ['u_00500','u_01000','u_01500','u_02000','u_02500','u_03000', \
              'u_03500','u_04000','u_04500','u_05000','u_05500','u_06000', \
              'u_06500','u_07000','u_07500','u_08000','u_08500','u_09000', \
              'u_09500','u_10000','u_10500','u_11000','u_11500','u_12000', \
              'u_12500','u_13000','u_13500','u_14000','u_14500','u_15000', \
              'u_15500','u_16000','u_16500','u_17000','u_17500','u_18000']

wind_status = 'failed'
while wind_status == 'failed':
    for var in awips_list:
        u = netcdf.variables[var]; u_flg = 0
        if np.max(abs(u[:])) != u_flg:
            wind_status = 'passed'
            break

print(wind_status)
