#!/bin/bash
#Next line helps to preserve blank spaces in file formatting
IFS=""
#trigger.txt should be in the directory where you are running the script
file='trigger.txt'
#initialize line number in input and output files
i=1
#Read the storm number as second parameter in call to this routine
stormadd=$(($2))
while read line; do
    if [ $i == 1 ]; then
#Get all the current date and time information in UTC
	month=$(date -u +%m)
	day=$(date -u +%d)
	year=$(date -u +%Y)
	hour=$(date -u +%H)
	minute=$(date -u +%M)
#eseconds is the epoch time,the time in seconds since Jan 1 1970 midnight
	eseconds=$(date -u +%s)
#Let the user know the name of the output trigger file
	echo "writing trigger file "$1$2"_"$year$month$day"_"$hour$minute"_trigger.txt"
#Set that same name for the output file name
	outfile=$1$2$"_"$year$month$day"_"$hour$minute"_trigger.txt"
#First line of trigger file is date in YYYYMMDD
	echo $year$month$day > $outfile
    elif [ $i == 2 ]; then
#For trigger which P3 aircraft doesn't matter since this is just to trigger
#    the HWRF ensemble, so write 42 to output trigger file
	echo "42" >> $outfile
    elif [ $i == 3 ]; then
#Initialize storm number
	stormno=0
#AL numbers are 101-199
#EP numbers are 201-299
#CP numbers are 301-399
	if [ $1 == "AL" ]; then
	    stormno=100
	elif [ $1 == "EP" ]; then
	    stormno=200
	elif [ $1 == "CP" ]; then
	    stormno=300
	fi
	stormno=$((stormadd+stormno))
	echo $stormno >> $outfile
#Lines 4-7 in the trigger file do not change so they are echoes, as is done
#      in the else section below
#Line 8 needs to be a 3 to indicate P3 malibu antenna, which is the one
#      that is needed to trigger the ensemble, so write 3 to output file
    elif [ $i == 8 ]; then
	echo "3" >> $outfile
    elif [ $i == 9 ]; then
#Determine the rest of the first data line that is not the epoch time
	restline=$(echo "$line" | cut -c 13-86)
#Substitute current epoch time in line 9 and append the rest of the line
#      from the template file trigger.txt
	echo "  ""$eseconds""$restline" >> $outfile
    else
#In all other lines just copy the line from input to output file
	echo "$line" >> $outfile
    fi
    i=$((i+1))
done<$file
exit
