      SUBROUTINE AZIUNFLDG(SWEEP,ISEG,ISEGE,MAX_GATES,NBINS,MAX_RAYS,
     1 XXNIQTA,RDTAI,AZ_EL,XXNIQ,NUM_RAYS,VRRAD,IUSEWIND,PAZM,
     1 ALLOWEDDIFF)
C SWEEP--Radial velocities with projection of aircraft motion removed
C ISEG and ISEGE--indicate segments between well behaved lines segments
C                 of radial velocity
C MAX_GATES--Dimensioning parameter for storage of VR in radial direction
C NBINS--Actual number of radial bins available for each VR
C MAX_RAYS--Dimensioning parameter for max number of radials in a sweep
C XXNIQTA--Not used--should be removed
C RDTAI--Radius in km of radial velocity from aircraft
C AZ_EL--Azimuth and elevation relative to the track of the aircraft
C XXNIQ--Effective Nyquist velocity (Nyquist velocity for single PRF)
C NUM_RAYS--Actual number of rays in the sweep
C VRRAD--Projection of background (guess) wind field on to radials
C IUSEWIND--Whether to use the background guess wind field to de-alias
C PAZM
      REAL SWEEP(MAX_GATES,MAX_RAYS)
      INTEGER ISEG(MAX_GATES,MAX_RAYS),ISEGE(MAX_GATES,MAX_RAYS)
      REAL RDTAI(MAX_GATES),AZ_EL(2,MAX_RAYS)
      REAL VRRAD(MAX_GATES,MAX_RAYS)
      REAL SWEEPKEEP(2048,800)
      REAL PAZM(800),DAZM(800)
C 
C XXNIQ IS THE DOPPLER RADAR NYQUIST VELOCITY 
C
      XXNIQ2=XXNIQ*2.
      XXNIQ5=XXNIQ*.5
c      WRITE(6,*)'ENTERED AZINUNFLDGUESS, MAX_GATES,NBINS = ',
c     1 MAX_GATES,NBINS
C 
C DAZM IS THE DIFFERENCE IN ROTATION AZIMUTH FROM THE FIRST RADIAL IN SWEEP
C
      DO J=1,NUM_RAYS
       DAZM(J)=PAZM(J)-PAZM(1)
      ENDDO
C 
C ITS BEEN A WHILE SINCE i WROTE THIS, BUT DAZM SHOULD ALWAYS INCREASE
C I BELIEVE THIS IS TO ACCOUNT FOR SWEEPS THAT DON'T START ABOVE ZERO
C AND STAY BELOW 360, WHICH APPLIES TO FRENCH-ANTENNA AFT SWEEPS AND
C MOST SWEEPS SINCE RVP8, WHERE SWEEPS DON'T START AT THE TOP
C
      DAZM(1)=0.
      IF(NUM_RAYS.GT.1)THEN
       DO J=2,NUM_RAYS
        IF(DAZM(J).LT.DAZM(J-1))THEN
         DAZM(J)=DAZM(J)+360.
        ENDIF
        IF(DAZM(J).LT.DAZM(J-1))THEN
         DAZM(J)=DAZM(J)+360.
        ENDIF
       ENDDO
      ENDIF
c      WRITE(6,*)'DAZM,PAZM = ',(DAZM(I),PAZM(I),I=1,NUM_RAYS)
c      OPEN(77,FILE='lister')
c      IF(IUSEWIND.NE.1)THEN
c      write(77,*)'iusewind = ',iusewind
c      write(77,*)'setting sweepkeep'
c       WRITE(6,*)'ONE'
C 
C COPY THE INPUT VELOCITY DATA IN SWEEP TO SWEEPKEEP
C
       DO J=1,NUM_RAYS
        DO I=1,MAX_GATES
         SWEEPKEEP(I,J)=SWEEP(I,J)
        ENDDO
       ENDDO
c      ENDIF
c      WRITE(6,*)'TWO'
C
C SEPARATE ALL THE RAYS IN A SWEEP INTO LINE SEGMENTS CONTAINING
C GOOD OR CONSISTENT (ACCORDING TO VELOCITY DIFFERENCE) VELOCITY DATA
C NON CONSECUTIVE DATA CAN BE IN THE SAME LINE SEGMENT SO LONG
C AS THE RADIAL GAP IS LESS THAN .91 KM
C
      DO J=1,NUM_RAYS
       IFIRST=0
       DO I=1,MAX_GATES
        ISEG(I,J)=0
       ENDDO
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800..AND.IFIRST.EQ.0)THEN
C
C---DETERMINE VERY FIRST GOOD GATE IN RAY
C
         BEFORE=SWEEP(I,J)
         IFIRST=1
         ISEG(I,J)=-1
         ILAST=I
        ELSEIF(SWEEP(I,J).GT.-800.)THEN
         IF(ABS(SWEEP(I,J)-BEFORE).GE.XXNIQ5.OR.
     1      RDTAI(I)-RDTAI(ILAST).GT..9)THEN
C
C        DIFFERENCE BETWEEN GATE AND PREVIOUS GOOD GATE MORE THAN
C         .5*NYQUIST VELOCITY
C        OR THERE ARE MORE THAN .91 KM IN A ROW OF VELOCITIES ARE FLAGGED
C 
C---ISEG AT THE LAST GOOD GATE BEFORE THIS LARGE SHIFT IS SET TO 1
C
          ISEG(ILAST,J)=1
          ISEG(I,J)=-1
C
C---ISEG AT THIS BREAKPOINT IS SET TO -1
C
         ENDIF
C
C        GOOD VALUES SET ILAST AND BEFORE TO THESE VALUES
C ILAST IS I OF THE LAST GOOD VALUE AND BEFORE IS THE SWEEP VELOCITY VALUE
C FOR THAT BIN
C 
         ILAST=I
         BEFORE=SWEEP(I,J)
        ENDIF
       ENDDO
C
C---VERY LAST GOOD VALUE GETS AN ISEG VALUE OF 1
C
       IF(IFIRST.EQ.1)ISEG(ILAST,J)=1
       IISEGE=-1
C
C THE FOLLOWING WILL CAUSE ALL DATA TO BE USED AND COMPARED TO NEXT AZMIUTH
C TO HAVE A CORRESPONDING ISEGE VALUE OF MAXIMUM I OF THE SEGMENT, 
C AND ALL DATA NOT TO BE COMPARED
C TO HAVE A VALUE OF -1
C
       DO I=MAX_GATES,1,-1
        IF(ISEG(I,J).EQ.1)THEN
         IISEGE=I
         ISEGE(I,J)=IISEGE
        ELSEIF(ISEG(I,J).EQ.-1)THEN
         ISEGE(I,J)=IISEGE
         IISEGE=-1
        ELSE
         ISEGE(I,J)=IISEGE
        ENDIF
       ENDDO
CCC
      ENDDO
CCC
      IUSETEST=0
      JMAX=0
c      WRITE(6,*)'THREE'
      DO J=1,NUM_RAYS
C
C FOR THE "RIGHT SIDE" WHICH IS THE FIRST HALF OF THE SWEEP
C
       IF(DAZM(J).GT.180..AND.DAZM(J).LT.320.)GO TO 777
       I=1
       JMAX=J
       DO WHILE(I.LE.NBINS-1)
C
C NSUMTOT WILL BE THE TOTAL NUMBER OF BINS IN A SEGMENT THAT ARE NOT FLAGGED
C
        NSUMTOT=0
C
C NSUM WILL BE THE TOTAL NUMBER OF BINS IN CURRENT AND PREVIOUS RAY
C   THAT BOTH HAVE UNFLAGGED VALUES (WITHIN A SINGLE SEGMENT)
C
        NSUM=0
        SUM=0
C
C NSUM2 IS THE NUMBER OF BINS THAT HAVE UNFLAGGED VALUES FOR
C FOR BOTH BACKGROUND AND OBSERVED RAYS
C
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
2777     IF(J-II.GE.1)THEN
          DO L=I,N
           IF(SWEEP(L,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800..AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800..AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
         ENDIF
C
C I THINK TESTSUM AND NSUMTEST ARE UNDEFINED SO I WILL COMMENT NEXT LINE
C         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTEST)+.00001)
C
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
C 
C NTEST IS NUMBER OF BINS WITHIN SEGMENT THAT CANNOT BE USED FOR SUMMATION
C
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 2777
c         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1.AND.NTEST.LT.10)THEN
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
C
C DIFMEAN IS THE MEAN DIFFERENCE BETWEEN RADIAL AND PREVIOUS RADIAL
C
          DIFMEAN=SUM/NSUM
C
C IF DIFMEAN IS GREATER THAN THE NYQUIST VELOCITTY THEN CHANGE 
C ALL THE VELOCITIES IN THE SEGMENT BY A MULTIPLE OF TWICE THE NYQUIST VELOCITY
C
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
C 
C NOW GO TO THE NEXT SEGMENT
C
         I=N+1
        ELSE
C
C NOW GO TO THE NEXT SEGMENT
C
         I=I+1
        ENDIF
       ENDDO        
      ENDDO
777   IF(JMAX.EQ.0)GO TO 678
C
C NOW REPEAT THE PROCESS IN THE OPPOSITE DIRECTION
C SEE THE CORRESPONDING COMMENTS ABOVE SINCE THEY WILL BE THE SAME
C
      DO J=JMAX,1,-1
       I=1
       DO WHILE(I.LE.NBINS-1)
        NSUMTOT=0
        NSUM=0
        SUM=0
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
2778     IF(J+II.LE.NUM_RAYS)THEN
          DO L=I,N
           IF(SWEEP(L,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
         ENDIF
C
C I BELIEVE AN UNDEFINED VARIABLE IN THE NEXT LINE (ALSO NOT USED)
C         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTOT)+.00001)
C
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 2778
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
          DIFMEAN=SUM/NSUM
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
         I=N+1
        ELSE
         I=I+1
        ENDIF
       ENDDO        
      ENDDO
776   NSUM=0
      SUM=0.
C
C COMPUTE THE MEAN DIFFERENCE BETWEEN BACKGROUND VELOCITIES AND THE
C DE-ALIASED VELOCITIES ARE REPORT IT FOR "RIGHT SIDE"
C
      DO J=1,JMAX
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'difference on right side is ',DIFF
C
C IF THE MEAN DIFFERENCE IS GREATER THAN THE NYQUIST VELOCITY THEN
C CHANGE THE WHOLE HALF SWEEP BY TWICE THE NYQUIST VELOCITY
C
       IF(ABS(DIFF).GT.XXNIQ)THEN
        IF(DIFF.GT.0.)THEN
         VCHANGE=-XXNIQ2
        ELSE
         VCHANGE=XXNIQ2
        ENDIF
        DO J=1,JMAX
         DO I=1,NBINS
          IF(SWEEP(I,J).GT.-800.)THEN
           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
          ENDIF
         ENDDO
        ENDDO
       ENDIF
      ELSE
       IUSETEST=0
      ENDIF
C
C IT IS AT THIS POINT THAT AZIUNFLDG (aziunfldguess.f) DIVERGES FROM
C    AZIUNFLD (aziunfld.f) WHERE REMOVAL OF SINGLE RADIALS OCCURS IF THERE
C    IS ENOUGH DIFFERENCE FROM THE BACKGROUND FIELD (AZIUNFLDG) AS OPPOSED TO
C    SIMPLY REMOVING A COMPLETE HALF SWEEP IF HALF-SWEEP MEAN DIFFERENCE FROM
C    INPUT HALF SWEEP BY MORE THAN A NYQUIST VELOCITY (AZIUNFLD)
C
      DO J=1,JMAX
       NSUM=0
       SUM=0
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
       IF(NSUM.GT.0)THEN
        DIFF=SUM/FLOAT(NSUM)
        IF(ABS(DIFF).GT.ALLOWEDDIFF)THEN
         DO I=1,NBINS
          SWEEP(I,J)=-888.88
         ENDDO
        ENDIF
       ENDIF
      ENDDO
      NSUM=0
      SUM=0.
      DO J=1,JMAX
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'second difference on right side is ',DIFF
      ENDIF
C
C AS OF JULY 23 2021, THIS ROUTINE IS ONLY USED WITH A BACKGROUND FIELD
C     SO THE THE NEXT IF SEGMENT (DOWN TO 678) WILL NOT BE DONE
C
      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
       NSUM=0
       SUM=0
       DO J=1,JMAX
        DO I=1,NBINS
         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
          NSUM=NSUM+1
         ENDIF
        ENDDO
       ENDDO
       IF(NSUM.GT.0)THEN
        DIFFMEAN=SUM/NSUM
        CHANGE=0.
        IF(DIFFMEAN.GT.XXNIQ)THEN
         CHANGE=-XXNIQ2
        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
         CHANGE=XXNIQ2
        ENDIF
        if(abs(change).gt..001)write(6,*)'right change = ',change
        IF(CHANGE.NE.0.)THEN
         DO J=1,JMAX
          DO I=1,NBINS
           IF(SWEEP(I,J).GT.-800.)THEN
            SWEEP(I,J)=SWEEP(I,J)+CHANGE
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ENDIF
      ENDIF
C
C THIS IS THE END OF THE RIGHT SIDE PROCESSING NOW DO THE SAME 
C FOR THE LEFT SIDE--INCREMENT J BACKWARDS FROM END OF SWEEP
C
678   IUSETEST=0
      JMIN=0
      DO J=NUM_RAYS,1,-1
       IF(DAZM(J).LT.180..AND.DAZM(J).GT.40.)GO TO 778
       I=1
       JMIN=J
       DO WHILE(I.LE.NBINS-1)
        NSUMTOT=0
        NSUM=0
        SUM=0
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
1777     IF(J+II.LE.NUM_RAYS)THEN
          DO L=I,N
           IF(SWEEP(I,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
         ENDIF
C
C I BELIEVE THE NEXT VARIABLE IS UNDEFINED AND IS NOT USED TO IT IS COMMENTED
C         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTOT)+.00001)
C
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 1777
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
          IUSETEST=1
          DIFMEAN=SUM/NSUM
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
         I=N+1
        ELSE
         I=I+1
        ENDIF
       ENDDO        
      ENDDO
778   IF(JMIN.EQ.0)GO TO 679
      DO J=JMIN,NUM_RAYS
       IF(DAZM(J).LT.180..AND.DAZM(J).GT.40.)GO TO 779
       I=1
       DO WHILE(I.LE.NBINS-1)
        NSUMTOT=0
        NSUM=0
        SUM=0
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
1778     IF(J-II.GE.1)THEN
          DO L=I,N
           IF(SWEEP(L,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
         ENDIF
C
C I BELIEVE THIS NEXT STATEMENT IS UNDEFINED AND NOT USED SO IT IS COMMENTED
C         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTOT)+.00001)
C
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 1778
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
          IUSETEST=1
          DIFMEAN=SUM/NSUM
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
C
C DO NEXT LINE SEGMENT
C
         I=N+1
        ELSE
         I=I+1
C
C DO NEXT LINE SEGMENT
C
        ENDIF
       ENDDO        
      ENDDO
779   NSUM=0
      SUM=0.
      DO J=JMIN,NUM_RAYS
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.
     1      VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'difference on left side is ',DIFF
       IF(ABS(DIFF).GT.XXNIQ)THEN
        IF(DIFF.GT.0.)THEN
         VCHANGE=-XXNIQ2
        ELSE
         VCHANGE=XXNIQ2
        ENDIF
        DO J=JMIN,NUM_RAYS
         DO I=1,NBINS
          IF(SWEEP(I,J).GT.-800.)THEN
           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
          ENDIF
         ENDDO
        ENDDO
       ENDIF
      ELSE
       IUSETEST=0
      ENDIF
C
C IT IS AT THIS POINT THAT AZIUNFLDG (aziunfldguess.f) DIVERGES FROM
C    AZIUNFLD (aziunfld.f) WHERE REMOVAL OF SINGLE RADIALS OCCURS IF THERE
C    IS ENOUGH DIFFERENCE FROM THE BACKGROUND FIELD (AZIUNFLDG) AS OPPOSED TO
C    SIMPLY REMOVING A COMPLETE HALF SWEEP IF HALF-SWEEP MEAN DIFFERENCE FROM
C    INPUT HALF SWEEP BY MORE THAN A NYQUIST VELOCITY (AZIUNFLD)
C
      DO J=JMIN,NUM_RAYS
       NSUM=0
       SUM=0
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.
     1      VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
       IF(NSUM.GT.0)THEN
        DIFF=SUM/FLOAT(NSUM)
        IF(ABS(DIFF).GT.ALLOWEDDIFF)THEN
         DO I=1,NBINS
          SWEEP(I,J)=-888.88
         ENDDO
        ENDIF
       ENDIF
      ENDDO
      NSUM=0
      SUM=0.
      DO J=JMIN,NUM_RAYS
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.
     1      VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'second difference on left side is ',DIFF
      ENDIF
C
C AS OF JULY 23 2021, THIS ROUTINE IS ONLY USED WITH A BACKGROUND FIELD
C     SO THE THE NEXT IF SEGMENT (DOWN TO 679) WILL NOT BE DONE
C
      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
       NSUM=0
       SUM=0
       DO J=JMIN,NUM_RAYS
        DO I=1,NBINS
         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
          NSUM=NSUM+1
         ENDIF
        ENDDO
       ENDDO
       IF(NSUM.GT.0)THEN
        DIFFMEAN=SUM/NSUM
        CHANGE=0.
        IF(DIFFMEAN.GT.XXNIQ)THEN
         CHANGE=-XXNIQ2
        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
         CHANGE=XXNIQ2
        ENDIF
        if(abs(change).gt..001)write(6,*)'left change = ',change
        IF(CHANGE.NE.0.)THEN
         DO J=JMIN,NUM_RAYS
          DO I=1,NBINS
           IF(SWEEP(I,J).GT.-800.)THEN
            SWEEP(I,J)=SWEEP(I,J)+CHANGE
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ENDIF
      ENDIF
679   VNYQ=XXNIQ
C
C THIS IS NOT IN AZIUNFLD (aziunfld.f)
C ONE LAST PASS THROUGH TO MAKE SURE THERE ARE STILL NOT POINTS
C WHERE SWEEP DIFFERENCE BY MORE THAN THE ALLOWED AMOUND FROM BACKGROUND
C
      DO JJ=1,NUM_RAYS
       DO II=1,NBINS
        IF(SWEEP(II,JJ).GT.-800..AND.VRRAD(II,JJ).GT.-800.)THEN
         DIFF=SWEEP(II,JJ)-VRRAD(II,JJ)
         IF(ABS(DIFF).GT.ALLOWEDDIFF)THEN
          SWEEP(II,JJ)=-888.88
         ENDIF
        ELSEIF(VRRAD(II,JJ).LE.-800.)THEN
         SWEEP(II,JJ)=-888.88
        ENDIF
       ENDDO
      ENDDO
      RETURN
      END
