C
C BEGINNING IN 2022, IT APPEARS THAT NCO WILL BE POSTING NEW DATA
C TYPES AT THEIR GATEWAY SITE:
C  https://tgftp.nws.noaa.gov/SL.us008001/DF.bb/DC.sluan/DS.recco/
C THEY HAVE ALWAYS CONCATENATED ALL FILES INTO ONE FILE EVERY 5 MINUTES
C THIS ROUTINE USES THE INFORMATION IN A SPECIAL BANNER THAT NOTIFES THE
C USER HOW MANY BYTES WILL BE IN THE MESSAGE (NOT INCLUDING THIS SPECIAL BANNER)
C IT MAKES A COPY OF THE FILE WHERE ALL MESSAGES THAT DO NOT HAVE THE 
C INDENTIFIER "16" IN THE FIRST LINE OF THE MESSAGE
C THE LARGEST PURPOSE OF THIS ROUTINE IS TO BE ABLE TO POST THE RESULTS AS
C SITUATIOBAL AWARENESS FOR THOSE MONITORING EMC DOPPLER DATA TRANSMITTED
C FROM THE NOAA AIRCRAFT
C
      PROGRAM BYTEMANIP
C THE FILE IS READ BYTE BY BYTE AND AND ANALYZED
      BYTE B(20000000),B1
C
C C2 IS FOR THE INDENTIFIER WHERE WE LOOK FOR "16"
C
      CHARACTER FILEIN*128,FILEOUT*128,C*1,C4*4,C2*2
C
C USE INPUT PARAMETERS TO MAKE THE PROGRAM EASIER TO USE IN SCRIPTS
C THE FIRST IS THE INPUT FILE WITH ALL THE DATA TYPES IN IT
C THE SECOND IS THE OUTPUT FILE WITH ONLY THE DOPPLER "16" DATA TYPE IN IT
C AND ALL OTHER TYPES REMOVED.  THE REMAINDER ARE KEPT CONCATENATED TO BE ABLE
C TO BE USED BY ANOTHER ROUTINE DESIGNED TO DECODE CONCATENATED DOPPLER FILES
C
      CHARACTER ARGCHARS(2)*80
      WRITE(6,*)'ENTER NAME OF INPUT FILE'
      DO I=1,2
         CALL GETARG(I,ARGCHARS(I))
      ENDDO
C      READ(5,'(A)')FILEIN
      FILEIN=ARGCHARS(1)
      FILEOUT=ARGCHARS(2)
C 
C OPEN THE GATEWAY-SITE FILE WITH ALL TYPES CONCATENATED
C
      OPEN(80,FILE=FILEIN,ACCESS='STREAM',FORM='UNFORMATTED')
      WRITE(6,*)'ENTER NAME OF OUTPUT FILE'
      OPEN(81,FILE=FILEOUT,ACCESS='STREAM',FORM='UNFORMATTED')
      WRITE(6,*)'FILE 81 OPENED'
C NTOTALBYTES REPRESENTS A COUNTER WITHIN THE INPUT FILE
      NTOTALBYTES=0
C NTOTALBYTESOUT REPRESENTS A COUNTER WITHIN THE OUTPUT FILE
      NTOTALBYTESOUT=0
C ICHECK USED FOR DO WHILE LOOP
      ICHECK=0
C NFILES IS THE TOTAL FILES PROCESSED
      NFILES=0
      DO WHILE(ICHECK.EQ.0)
C NSTART IS THE STARTING POINT OF EACH FILE
C NEND IT IS ASSUMED THE NUMERICAL BANNER WILL NOT BE MORE THAN 21 BYTES
C NOT ALL NUMERICAL BANNERS ARE THE SAME LENGTH BUT THEY APPEAR TO BE LESS
C THAN OR EQUAL 21 BYTES
         NSTART=NTOTALBYTES+1
         NEND=NTOTALBYTES+21
         DO J=NSTART,NEND
C
C END OPTION IS NOT AN OPTION WITH A STREAM TYPE FILE, BUT THERE WILL BE 
C AN ERROR IF THE READ TRIES TO READ PAST THE END OF INPUT FILE
C IF SO CLOSE THE FILES AND STOP BY GOING TO STATEMENT LABEL 999
C
            READ(80,REC=J,ERR=999)B(J)
            I=B(J)
C
C DEBUG DATA SHOWING EACH CHARACTER IN THE BANNER
C
            WRITE(6,'(2I4,X,A)')J,I,I
            WRITE(C,'(A1)')I
            WRITE(6,*)C
         ENDDO
C INCREMENT THE NUMBER OF PROCESSED CONCATENATED FILES
         NFILES=NFILES+1
C THE FIRST 7 CHARACTERS ARE IGNORED AND THEN NUMBERS ARE READ
C M IS THE POSITION WITHIN THE OUTPUT FILE
C N IS THE POSITION WITHIN THE OUTPUT FILE
C IBYTES IS THE TOTAL NUMBER OF BYTES IN EACH CONCATENATED MINUS THE
C THE LINE CONTAINING THE NUMERICAL BANNER
C
         M=8
         N=8+NTOTALBYTES
         IBYTES=0
C
C THE CHARACTER "#" WILL IMMEDIATELY FOLLOW THE NUMMBER OF BYTES IN
C THE NUMERICAL HEADER
C
         DO WHILE(C.NE."#")
            WRITE(C,'(A1)')B(N)
C
C THE ASCII VALUE FOR A NUMBER IS 48 MORE THAN THE NUMBER
C INCREMENT THE VALUE OF IBYTES AS EACH SINGLE DIGIT IS READ
C
            IF(C.NE."#")IBYTES=IBYTES*10+B(N)-48
            WRITE(6,*)IBYTES
C
C INCREMENT THE VALUES OF N AND M AS EACH DIGIT IS READ
C
            N=N+1
            M=M+1
         ENDDO
C
C THERE APPEAR TO ALWAYS BE 4 "#" CHARACTERS AFTER THE NUMBER OF BYTES NUMBER
C
         N=N+4
         M=M+4
C
C DEBUG OUTPUT TO MAKE SURE WE ARE POSITIONED CORRECTLY SINCE THE FIRST
C CHARACTER IN THE WMO BANNER IS "U"
C
         READ(80,REC=N)B1
         WRITE(C,'(A1)')B1
         WRITE(6,*)C
C
C NFIRSTLINE AND MFIRSTLINE THE LOCATION OF THE LAST BYTE IN THE 
C NUMERICAL HEADER
C
         NFIRSTLINE=N-1
         MFIRSTLINE=M-1
C
C DEBUG OUTPUT
C
         WRITE(6,*)'NFIRSTLINE,MFIRSTLINE = ',
     +    NFIRSTLINE,MFIRSTLINE
C
C THE DATA TYPE NUMBER START ON 5TH CHARACTER AFTER THE PREVIOUS CARRIAGE FEED
C READ THE TWO CHARACTERS OF THE STATION IDENTIFIER
C
         READ(80,REC=NFIRSTLINE+5)(B(I),I=1,2)
C
C C4 WILL BE THE STATION IDENTIFIER AS A CHARACTER
C
         WRITE(C2,'(2A1)')(B(I),I=1,2)
         WRITE(6,*)'DATA TYPE NUMBER IS ',C2
C
C IF THE IDENTIFIER IS 16 WRITE THE FILE TO THE OUTPUT
C
         IF(C2.EQ.'16')THEN
C 
C POSITION TO READ THE ENTIRE NUMERICAL HEADER INTO B
C SO IREAD1 IS THE POSITION IN THE FILE OF THE VERY FIRST CHARACTER OF THE
C NUMERICAL BANNER
C
            IREAD1=NTOTALBYTES+1
            READ(80,REC=IREAD1)(B(I),I=1,MFIRSTLINE)
C
C IWRITE1 IS THE POSITION OF THE FIRST BYTE IN THE NEXT CONCATENATED FILE
C
            IWRITE1=1+NTOTALBYTESOUT
            WRITE(81,REC=IWRITE1)(B(I),I=1,MFIRSTLINE)
C
C IREAD2 IS THE POSITION IN THE INPUT FILE OF THE FIRST BYTE OF THE WMO
C HEADER IN THE NEXT CONCATENATED FILE
C
            IREAD2=NFIRSTLINE+1
C
C READ IN THE REST OF THE FILE (MINUS THE INPUT BANNER)
C
            READ(80,REC=IREAD2)(B(I),I=1,IBYTES)
C
C IWRITE2 IS THE POSITION IN THE OUTPUT FILE OF THE FIRST BYTE OF THE WMO
C HEADER IN THE NEXT CONCATENATED FILE
C
            IWRITE2=MFIRSTLINE+1+NTOTALBYTESOUT
C
C WRITE THE REST OF THE NEXT CONCATENATED FILE INTO THE OUTPUT FILE
C
            WRITE(81,REC=IWRITE2)(B(I),I=1,IBYTES)
C
C DEBUG OUTPUT
C
            WRITE(6,*)'IREAD1,IWRITE1,IREAD2,IWRITE2 = ',
     +         IREAD1,IWRITE1,IREAD2,IWRITE2
C
C NTOTALBYTESOUT WILL BE THE POSITION OF THE LAST BYTE IN THE OUTPUT FILE
C SO IT IS INCREMENTED BY THE SIZE OF THE NUMERICAL BANNER AND THE SIZE
C OF THE REST OF THE FILE.  THIS IS IT IS ONLY INCREMENTED IF 
C IDENTIFIER IS 16
C
            NTOTALBYTESOUT=NTOTALBYTESOUT+MFIRSTLINE+IBYTES
         ENDIF
C
C NOTALBYTES IS THE POSITION OF THE END OF THE NEXT CONCATENATED FILE
C IN THE INPUT FILE, SO IT IS INCREMENTED WHETHER THE IDENTIFIER WAS 16 OR NOT
C
         NTOTALBYTES=NFIRSTLINE+IBYTES
C
C DEBUG OUTPUT
C
         WRITE(6,*)'NTOTALBYTES,NTOTALBYTESOUT = ',
     +              NTOTALBYTES,NTOTALBYTESOUT
      ENDDO
 999  CLOSE(80)
      CLOSE(81)
C
C DEBUG OUTPUT
C
      WRITE(6,*)'NFILES = ',NFILES
      STOP
      END
