#!/usr/bin/perl

# fix_profile_plot_label.pl
# Modified from UCAR/ATD ps2eps.pl included with grid2ps
# Script to fix a ps profile file
# generated by plotced 

# require "getopt.pl";

# MAKE SURE THE USAGE IS CORRECT
# -o=output text file
if ($#ARGV<0) {
   print "\nUSAGE: fix_profile_plot.pl\n";
   print "\t-i 'postscript filename'\n";
   print "\t-o 'outout postscript filename'\n";
   print "\t-a 'azimuth in deg (int)''\n";
   print "\t-help 'help'\n\n";
   exit();
} else {
   &Getopt('ioaht');
}

if ($opt_h eq "elp") {&print_help;}

&get_az;

&generate_out; 
#**************************************************
sub print_help {

   # Print option info
   print "\n   fix_profile_plot.pl changes Y= label to azimuth\n";
   print "OPTIONS:\n";
   print "\t-i:\tName of postscript file ";
   print "generated in plotced or grid2ps\n\n";
   print "\t-o:\tName of output ps file\n\n";
   print "\t-l:\tazimuth.\n";
   print "\tExample:  fix_profile_plot.pl -i test.ps -o new_test.ps -a 186\n";
   print "\tNote: the azimuth should be intger\n";
   exit();
   
}
#******************************************
sub get_az {

   if ($opt_a ne "") {
	$az = $opt_a;
   } else {
      print "Warning: no az specified...";
      print "using default az 0 \n";
      $az = '0';
   } # endif

}
#******************************************
sub generate_out {

   open (PS, "$opt_i") || die "cannot open $opt_i";
   open (EPS, ">$opt_o") || die "cannot open $opt_o";

   $date = `date`;
   chop($date);
   while (<PS>) {
      chop;
# Note use of \( because ( is special character in regular experession
      if (/^box_w box_h sp_horiz_text add 0 \(Y=  0.00\)4 1 text_pos/) {
#	print "changing y=0.0 azis label \n";
	 print EPS "box_w box_h sp_horiz_text add 0 (Azimuth: ";
	 print EPS " $az deg";
	 print EPS ")4 1 text_pos \n";
      } elsif (/^box_w box_h sp_horiz_text add 0 \(Y=-15.00\)4 1 text_pos/) {
#	print "changing y=-15.0 azis label \n";
	 print EPS "box_w box_h sp_horiz_text add 0 (Azimuth: ";
	 print EPS " $az deg";
	 print EPS ")4 1 text_pos \n";
      } elsif (/^box_w box_h sp_horiz_text add 0 \(Y= 15.00\)4 1 text_pos/) {
#	print "changing y=15.0 azis label \n";
	 print EPS "box_w box_h sp_horiz_text add 0 (Azimuth: ";
	 print EPS " $az deg";
	 print EPS ")4 1 text_pos \n";
      } else {
         print EPS "$_\n";
      }
   }
   print EPS "%%EOF\n";

   close(PS);
   close(EPS);

}
#******************************************
;# $RCSfile: getopt.pl,v $$Revision: 4.1 $$Date: 92/08/07 18:23:58 $
#
# This library is no longer being maintained, and is included for backward
# compatibility with Perl 4 programs which may require it.
#
# In particular, this should not be used as an example of modern Perl
# programming techniques.
#
# Suggested alternatives: Getopt::Long or Getopt::Std
#
;# Process single-character switches with switch clustering.  Pass one argument
;# which is a string containing all switches that take an argument.  For each
;# switch found, sets $opt_x (where x is the switch name) to the value of the
;# argument, or 1 if no argument.  Switches which take an argument don't care
;# whether there is a space between the switch and the argument.

;# Usage:
;#	do Getopt('oDI');  # -o, -D & -I take arg.  Sets opt_* as a side effect.

sub Getopt {
    local($argumentative) = @_;
    local($_,$first,$rest);
    local($[) = 0;

    while (@ARGV && ($_ = $ARGV[0]) =~ /^-(.)(.*)/) {
	($first,$rest) = ($1,$2);
	if (index($argumentative,$first) >= $[) {
	    if ($rest ne '') {
		shift(@ARGV);
	    }
	    else {
		shift(@ARGV);
		$rest = shift(@ARGV);
	    }
	    ${"opt_$first"} = $rest;
	}
	else {
	    ${"opt_$first"} = 1;
	    if ($rest ne '') {
		$ARGV[0] = "-$rest";
	    }
	    else {
		shift(@ARGV);
	    }
	}
    }
}

1;
