      PROGRAM MAKE_SWEEPS_LIST
C 
C Make the list of RVP8 and RVP-900 TDR sweeps files, 
C in the proper chronological order, 
C that will be read in to interpolate the TDR reflectivity and radial velocity 
C
C DIRECTORY NAME IS THE FULL PATH TO THE DIRECTORY CONTAINING SWEEP FILES
      CHARACTER DIRECTORYNAME*132,DUMMY*132,COMMAND*132,SKIP_STRING*8
      CHARACTER DIRECTORYNAME2*132,FLID*10
      LOGICAL DEVSHMFLIDFILE
      CHARACTER CDATE*6,CPLANE*1
      INTEGER CDATE2
C
C jobfile_radar is the jobfile to make the 3D file
      INQUIRE(FILE='/dev/shm/FLID',EXIST=DEVSHMFLIDFILE)
      IF(DEVSHMFLIDFILE)THEN
         OPEN(80,FILE='/dev/shm/FLID')
         READ(80,'(A10)')FLID
         WRITE(6,*)'FLID = ',FLID
         READ(FLID,'(2X,A6,A1)')CDATE,CPLANE
         WRITE(6,*)'CDATE,CPLANE = ',CDATE,CPLANE
         WRITE(DIRECTORYNAME,972)FLID
 972     FORMAT('/home/sysop/',A10,'/')
         IREADREST=0
      ELSE
         OPEN(80,FILE='jobfile_radar')
C
C CDATE is character variable of date of start of flight in form YYMMDD
C
C CPLANE IS H, I, OR N, 
C corresponding to 42 (P3), 43 (P3), and 49 (G-IV), respectively
         READ(80,'(A6,A1)')CDATE,CPLANE
         IREADREST=1
      ENDIF
      WRITE(6,'(A6)')CDATE
      WRITE(6,'(A1)')CPLANE
      READ(CDATE,'(I2)')CDATE2
      WRITE(6,*)'CDATE2 = ',CDATE2
C
C The next 22 lines in jobfile_radar are not needed to catalog sweep files
      IF(IREADREST.EQ.1)THEN
         DO I=1,22
            READ(80,'(A)')DUMMY
         ENDDO
C
C Read the path to the directory containing RVP8 or RVP-900 sweep files
         READ(80,'(A)')DIRECTORYNAME
         CLOSE(80)
      ENDIF
      WRITE(6,*)'DIRECTORY NAME IS ',DIRECTORYNAME
      CALL SYSOPCHANGE(DIRECTORYNAME,DIRECTORYNAME2)
      DIRECTORYNAME=DIRECTORYNAME2
      WRITE(6,'(A)')DIRECTORYNAME
C
C Write the command to list files in the way radar_rvp8_read reads them
	command = " "
C note modified command string to sort
C list...so that master (nrm*.RA@) and slave
C (nrs*.RAW) will be properly interleaved in the
C list
	nc = len(trim(directoryname)) + 4
	skip_string = ' '
	if(nc .lt. 10) then
	   write(skip_string,"(' -k 1.',i1,1x)")nc
	else
	   write(skip_string,"(' -k 1.',i2,1x)")nc
	end if
        write(6,*)'cdate2 = ',cdate2
C
C The next line is satisfied if the plane is 43 from any year
C before 2019 or the year is 2016 or before and the plane is a P3
C This also means the P3 data are not dual-transmitter data
        if((cdate2.le.18.and.cplane.eq.'I').or.
     +     (cdate2.le.16.and.cplane.eq.'H'))then
C
C All P3 sweep files before dual P3 transmitters have TA and RAW in them
         command = 'ls ' // trim(directoryname)
     +	   //'*TA*RAW* | sort'//skip_string//'  > sweeps_list'
C
C Test whether aircraft and year indicate dual transmitters
C
C Fore sweeps begin with TM for master 
C and aft sweeps begin with TS for slave
        elseif((cplane.eq.'H'.and.cdate2.gt.16).or.
     +         (cplane.eq.'I'.and.cdate2.gt.18))then
         command = 'ls ' // trim(directoryname)
     +	   //'*T*RAW* | sort'//skip_string//'  > sweeps_list'
C
C If the data are not from 42 or 43 they are from 49 and do the following
        else
         command = 'ls ' // trim(directoryname)
     +	   //'*nr*RAW* | sort'//skip_string//'  > sweeps_list'
        endif
      WRITE(6,*)'COMMAND = ',COMMAND
      CALL SYSTEM(COMMAND)
C
C wrote the command that will do an ls -l on the sweeps so
C ground radar operator can see if there is a problem with file sizes
	nc = len(trim(directoryname)) + 47
	skip_string = ' '
	if(nc .lt. 10) then
	   write(skip_string,"(' -k 1.',i1,1x)")nc
	else
	   write(skip_string,"(' -k 1.',i2,1x)")nc
	end if
        write(6,*)'cdate2 = ',cdate2
        if((cdate2.le.18.and.cplane.eq.'I').or.
     +     (cdate2.le.16.and.cplane.eq.'H'))then
         command = 'ls ' // trim(directoryname)
     +	   //'*TA*RAW* | sort'//skip_string//'  > sweeps_list'
        elseif((cplane.eq.'H'.and.cdate2.gt.16).or.
     +         (cplane.eq.'I'.and.cdate2.gt.18))then
         command = 'ls ' // trim(directoryname)
     +	   //'*T*RAW* | sort'//skip_string//'  > sweeps_list'
C
C If the data are not from 42 or 43 they are from 49 and do the following
        else
         command = 'ls ' // trim(directoryname)
     +	   //'*nr*RAW* | sort'//skip_string//'  > sweeps_list'
        endif
        write(6,*)'cplane, and cdate2 = ',cplane,cdate2
        if(cdate2.le.16.and.cplane.ne.'N')then
         command = 'ls -l ' // trim(directoryname)
     +	   //'*TA*RAW* | sort'//skip_string//'  > long_sweeps_list'
        elseif((cplane.eq.'H'.and.cdate2.gt.16).or.
     +         (cplane.eq.'I'.and.cdate2.gt.18))then
         command = 'ls -l ' // trim(directoryname)
     +	   //'*T*RAW* | sort'//skip_string//'  > long_sweeps_list'
        else
         command = 'ls -l ' // trim(directoryname)
     +	   //'*nr*RAW* | sort'//skip_string//'  > long_sweeps_list'
        endif
      WRITE(6,*)'COMMAND = ',COMMAND
      CALL SYSTEM(COMMAND)
      STOP
      END
      SUBROUTINE SYSOPCHANGE(RADARFILE,RADARFILEOUT)
      CHARACTER CWD*132,RADARFILE*132,RADARFILEOUT*132
      CHARACTER SYSOP*11,SYSOPREST*132
      CHARACTER*1 ONE(132),TWO(132),THREE(132)
      LOGICAL SYSOPCHANGEFILE
      INQUIRE(FILE='sysopchange',EXIST=SYSOPCHANGEFILE)
      IF(SYSOPCHANGEFILE)THEN
         OPEN(81,FILE='sysopchange')
         READ(81,'(A)')CWD
C      CALL GETCWD(CWD)
      ELSE
         RADARFILEOUT=RADARFILE
         RETURN
      ENDIF
c      WRITE(6,*)'CWD = ',CWD
      ILENPREFIX=LEN_TRIM(CWD)
c      WRITE(6,*)'ILENPREFIX = ',ILENPREFIX
      READ(CWD,'(132A1)')(ONE(I),I=1,ILENPREFIX)
      READ(RADARFILE,'(A11,A)')SYSOP,SYSOPREST
c      WRITE(6,'("SYSOP = ",A11)')SYSOP
c      ISYSOP=0
c      IF(SYSOP.EQ.'/home/sysop')ISYSOP=1
c      WRITE(6,*)'ISYSOP = ',ISYSOP
c      PAUSE
c      WRITE(6,'("SYSOPREST = ",A)')SYSOPREST
      NSLASH=0
      NCHAR=ILENPREFIX
      NSLASH=0
      READ(RADARFILE,'(132A1)')ONE
      DO I=1,132
         IF(ONE(I).EQ.'/')THEN
            NSLASH=NSLASH+1
            NCHAR2=NCHAR3
            NCHAR3=I
         ENDIF
      ENDDO
      SYSOPREST=' '
      WRITE(SYSOPREST,'(132A1)')(ONE(I),I=NCHAR2,132)
      ILENTRIM=LEN_TRIM(SYSOPREST)
      DO I=1,132
         TWO(I)=' '
      ENDDO
      READ(CWD,'(132A1)')(TWO(I),I=1,NCHAR)
      ISTART=NCHAR+1
      IEND=ISTART+ILENTRIM-1
      READ(SYSOPREST,'(132A1)')(TWO(I),I=ISTART,IEND)
      WRITE(RADARFILEOUT,'(132A1)')(TWO(I),I=1,IEND)
      RETURN
      END
