C	plot10_postscript
C  PostScript emulation of plot 10 calls, plus some extra subroutines
C
	subroutine initl(plotter, ires, iwid, iht, im1, im2, im3)
	integer plotter, ires, iwid, iht, im1, im2, im3
	character*64 outfile
	character*80 string 
	common /post_guphe/ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	data ifirst/ 1/ ! on next call will be 2 etc...
	data scale /1.0 /
C
	plotter = -1 ! returned
	if( ifirst .eq. 1)then
	    ifirst = ifirst + 1
	    ipst_file = im1 ! i/o unit, so no clash with units open in main
	    if( im2. gt. 0) then
	       ifont_pts = im2 ! font size in points ( 1/72 of inch)
	    else
		ifont_pts = 16 ! default
	    end if
	    ipage_orien = im3 ! 0 - portrait (default), 1 - landscape
	    WRITE(6,*)' Enter postscript output file (< 64 ch): '
	    READ(5,'(a)')outfile
	    open(ipst_file, file = outfile, form = 'formatted')
C write prologue to file. This contains procedure definitions etc.
	    in = ipst_file + 1 
Cout	    open(in, file = '/users/peter/motif_learn.d/ps_prolog.dat',
	    open(in, file = '/home/hrd/ps_prolog.dat',
     +      	form = 'formatted', status = 'old')
	    do i = 1, 4
		read(in,11,end = 12)string
11		format(a) 
		write(ipst_file,11)string
	    end do
	    iur_x = iwid * 7.2 ! inches x 10 to points
	    iur_y = iht *7.2
	    write(ipst_file,111)0,0, iur_x, iur_y
111	    format('%%BoundingBox:',4(1x,i4))
C read in rest of prolog file
10	    read(in,11,end = 12)string
	    write(ipst_file,11)string
      	    go to 10
12	    close(in) 
	    xp0 = 0.0 ! coordinate system origin
	    yp0 = 0.0
		xlast = xp0
		ylast = yp0
C If needed, set for landscape mode:
	    if( ipage_orien .eq. 1 ) then
		write(ipst_file,*)'% Set to landscape orientation'
		write(ipst_file,*)' 90 rotate'
		write(ipst_file,*)' 0 -612 translate'
	    end if
C Set font
	    write(ipst_file, *)'/Helvetica findfont'
	    write(ipst_file, *)ifont_pts,' scalefont'
	    write(ipst_file, *)'setfont'
C Set Line Width
	    write(ipst_file, *)' 1 setlinewidth'
C	  else ! Plot was already initialized, so ignore
	end if	    
	return
	end
C -----------------------------------
	subroutine init_ps(wid, ht, ips_lu, ifont_size, 
     +		line_width, ipage_orien,
     +		outfile, font_name, ierr_flag)
C wid, ht: width and height of plotting area in inches
C ips_lu: PostScript file lu
C ifont_size: initial size of font, in points
C line_width: initial line width in points
C ipage_orien = 0 - portrait, 1 - landscape
C outfile: output file name
C font_name: Font for text, like Times-Roman or Helvetica
C ierr_flag: 0 - file opened, -1: - file open error
	real wid, ht
	character font_name*(*)
	character outfile*(*)
	character*80 string 
	common /post_guphe/ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	data ifirst/ 1/ ! on next call will be 2 etc...
	data scale /1.0 /
C
	if( ifirst .eq. 1)then
		ierr_flag = 0
	    ipst_file = ips_lu
	    ifont_pts = ifont_size
	    ifirst = ifirst + 1
	    open(ipst_file, file = outfile, form = 'formatted',
     +		err = 999, iostat = ierr)
C write prologue to file. This contains procedure definitions etc.
	    in = ipst_file + 1 
Cout	    open(in, file = '/users/peter/ps_prolog.dat',
	    open(in, file = '/home/hrd/ps_prolog.dat',
     +      	form = 'formatted', status = 'old')
	    do i = 1, 4
		read(in,11,end = 12)string
11		format(a) 
		write(ipst_file,11)string
	    end do
	    iur_x = wid * 7.2 ! inches x 10 to points
	    iur_y = ht *7.2
	    write(ipst_file,111)0,0, iur_x, iur_y
111	    format('%%BoundingBox:',4(1x,i4))
C read in rest of prolog file
10	    read(in,11,end = 12)string
	    write(ipst_file,11)string
      	    go to 10
12	    close(in) 
	    xp0 = 0.0 ! coordinate system origin
	    yp0 = 0.0
		xlast = xp0
		ylast = yp0
C If needed, set for landscape mode:
	    if( ipage_orien .eq. 1 ) then
		write(ipst_file,*)'% Set to landscape orientation'
		write(ipst_file,*)' 90 rotate'
		write(ipst_file,*)' 0 -612 translate'
	    end if
C Set font
	    write(ipst_file, *)'/'//font_name//' findfont'
	    write(ipst_file, *)ifont_pts,' scalefont'
	    write(ipst_file, *)'setfont'
C Set Line Width
	    write(ipst_file, *)line_width,' setlinewidth'
C	  else ! Plot was already initialized, so ignore
	end if	    
	return
999	ierr_flag = -1
	return
	end
C ------------------------------------------------------------------------
	subroutine plot(x, y, ipen)
	real x, y
	integer ipen
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	call my_ps_plot(x, y, ipen, ipst_file, xp0, yp0, scale,
     +		last_pen)
	xlast = x
	ylast = y
	last_pen = ipen
	if( ipen .eq. 998) then ! file was closed so reset first
		ifirst = 1
	end if
	return
	end
C ------------------------------------------------------------------------
	subroutine newpn( ipen)
	integer ipen
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	call my_ps_newpn(ipen, ipst_file, last_pen)
C Re-initialize path, because my_ps_newpn does a 
C stroke, so new color does not apply to alredy "drawn" segments...
	call plot(xlast, ylast, 3)
	return
	end
C --------------------------------------------------------------------
	subroutine symbl(x, y, csize, istring, orien, num_ch)
	real x, y, csize, orien
	integer num_ch
	integer*2 istring(50)
	character string*100
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
C
	new_font_pts = nint( abs(csize) * 72.0 * scale)
Cout	new_font_pts = nint( abs(csize) * 72.0 * 1.5 * scale)
	if((new_font_pts .ne. ifont_pts) .and. 
     +	    (new_font_pts .gt. 0)) then
C have to resize font:
		ifont_pts = new_font_pts
	end if
C
	nwds = nint( (num_ch+1) * 0.5)
	write(string,100)(istring(i), i = 1, nwds)
100	format(50(a2))
COUT	write(6,*)' Attempting to write string :',string
	if( csize .gt. 0.0) then
	  call my_ps_symbl(x, y, num_ch, string, orien, 
     +			ipst_file, xp0, yp0, scale, ifont_pts)
	else
	  call my_ps_symbl(x, y, -num_ch, string, orien, 
     +			ipst_file, xp0, yp0, scale, ifont_pts)
	end if
	return
	end
C --------------------------------------------------------------------
	subroutine rstr(icode)
	integer icode
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
C
	call my_ps_plot(0.0, 0.0, 998, ipst_file, xp0, yp0,
     +			scale, last_pen)
	ifirst = 1 ! so next initl call gets file
	return
	end
C =================================================================
	subroutine numbr(x, y, csize, data, rotation, nfrac)
C Plots real numbers, using nfrac decimal places. Note that this subroutine
C could fail, perhaps drastically, if data > 1.0e7, because real #'s only
C have that much precision in IEEE 4 byte reals. So, to avoid that problem
C this implementation will convert large numbers to scientific format.
	real x, y, csize, data, rotation
	integer nfrac
	integer whole
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	character rm_str*10, wh_str*10, outstring*22
	integer*2 istring(11)
C I do the formatting here and pass to C function for printing.
	outstring = ' '
	wh_str = ' '
	rm_str = ' '
	real_max = 1.0e7
	if( abs(data) .gt. real_max) then !  <:>  <:>  <:>  <:>  <:>  <:>  
C convert to scientific notation
		write(outstring(1:8),'(e8.2e2)')data
		read(outstring,'(4a2)')(istring(i), i = 1,4)
		call symbl(x, y, csize, istring, rotation, 8)
	else ! give the users what they want  <:>  <:>  <:>  <:>  <:>  <:>
C
	if( nfrac .le. 0) then ! round integer part
	   whole = nint(abs(data) )
	   if( data .lt. 0) whole = -whole
	   if( abs(whole) .ge. 1)then
		nw = int( log10( float(abs(whole)) )) + 1
		write(wh_str,'(i10)')whole
		if (data .lt. 0.0) then
			nw = nw + 1
		end if
	   else if (whole .eq. 0) then
		if( data .lt. 0.0) then
		   nw = 2
		   wh_str(9:10) = '-0'
		else
		   nw = 1
		   wh_str(10:10) = '0'
		end if
	   end if
	   if( nfrac .eq. 0) then
	  	outstring = wh_str(11-nw:10)//'.'
	  	num_ch = nw + 1
	   else if( nfrac .lt. 0) then
	  	outstring = wh_str(11-nw:10)
	  	num_ch = nw
	   end if
	else ! nfrac > 0  ..................................................
C Max decimal pts i allow is 10, and 10 places on other side...
	   if( nfrac .gt. 10)then
		iend = 10
	   else
		iend = nfrac
	   end if
C extract the decimal part
	   whole = int( data ) ! NOT nint...
d	write(6,*)' data: ',data
d	write(6,*)' nfrac: ', nfrac
d	write(6,*)' 10.0 **nfrac ',10.0 **nfrac
d	write(6,*)' data * (10.0 **nfrac) ',
d    +		data * (10.0 **nfrac)
d	write(6,*)' nint(data * (10.0 **nfrac)) ',
d    +		nint(data * (10.0 **nfrac))
	   write(outstring,'(i20)')nint(data * (10.0 **nfrac))
d	write(6,*)' Outstring: ',outstring
	   do i = 1, iend
		rm_str(11-i:11-i) = outstring(21-i:21-i)
	   end do
	   if( abs(whole) .gt. 0 )then
d	write(6,*)' float(abs(whole)) ',float(abs(whole))
		nw = int( log10( float(abs(whole)) )) + 1
d	write(6,*)' whole, nw:', whole, nw
		write(wh_str,'(i10)')whole
		if (data .lt. 0.0) then
			nw = nw + 1
		end if
	   else if (whole .eq. 0) then
		if( data .lt. 0.0) then
		   nw = 2
		   wh_str(9:10) = '-0'
		else
		   nw = 1
		   wh_str(10:10) = '0'
		end if
	   end if
	   num_ch = nw + 1 + nfrac
	   outstring = wh_str(11-nw:10)//'.'//rm_str(11-nfrac:10)
	end if ! .......................................................
        read(outstring,'(11a2)')(istring(i), i = 1,11)
	call symbl(x, y, csize, istring, rotation, num_ch)
C
	end if ! <:>  <:>  <:>  <:>  <:>  <:>  <:>  <:>  <:>  <:>  <:>  
	return
	end
C -------------
	subroutine plot10_circle(x, y, radius, w, vis)
	real x, y, radius, w(4)
	logical vis
C
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
C
	vis = .false.
	if( inside_box(x,y,w) .eq. 0) then
C Center of circle is in window
		vis = .true.
	else
C Check to see if window intersects circle:
		r_sq = radius**2
C Part of circle is visible iff at least one corner of window on or inside
C circle:
		if( (((w(1) - x)**2 + (w(2) - y)**2) .le. r_sq) .or.
     + 	 	   (((w(1) - x)**2 + (w(4) - y)**2) .le. r_sq) .or.
     + 	 	   (((w(3) - x)**2 + (w(2) - y)**2) .le. r_sq) .or.
     +	 	   (((w(3) - x)**2 + (w(4) - y)**2) .le. r_sq) ) 
     +		   vis = .true.
	end if
C and make Postscript code to draw circle, clipped to window defined by w
	if( vis ) then ! part or all of arc visible, so do postscript circle
		   call my_ps_circle(x, y, radius, w, ipst_file,scale)
	end if
	return
	end
C ---
	subroutine penup
	common /post_guphe/ ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	last_pen = 3
	call plot(xlast, ylast, 3)
	return
	end
C ----
	subroutine pendn
	common /post_guphe/ ipst_file, xp0, yp0,last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	last_pen = 2
	return
	end
C -----
	subroutine factr(ratio)
C This is called to scale a plot. So need to add appropriate
C PostScript code later....
	common /post_guphe/ ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
	scale = ratio
	write(ipst_file,*)'% Internal ratio (factr) set to: ',ratio
	return
	end
C
C --------------------------------------------------------------------
	subroutine my_write(x, y, csize, string, orien, itype, num_ch)
C symbl that is passed string of characters, and that can be right, left
C or centered.
	real x, y, csize, orien
	integer num_ch
	character string*100
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
C
	new_font_pts = nint( abs(csize) * 72.0 * scale)
Cout	new_font_pts = nint( abs(csize) * 72.0 * 1.5 * scale)
	if((new_font_pts .ne. ifont_pts) .and. 
     +	    (new_font_pts .gt. 0)) then
C have to resize font:
		ifont_pts = new_font_pts
	end if
C
	  call ps_write(x, y, num_ch, string, orien, 
     +			ipst_file, xp0, yp0, scale, ifont_pts,itype)
	return
	end
C
	subroutine my_exp_write(x, y, csize, string, orien, num_ch)
C symbl that is passed string of characters taht includes super and
C subscripts. string starts at xy.
	real x, y, csize, orien
	integer num_ch
	character string*(*)
	common /hideyhole/ im_struct(30)
	common /post_guphe/ ipst_file, xp0, yp0, last_pen,
     +		scale, ifirst, ifont_pts, xlast, ylast
C
	new_font_pts = nint( abs(csize) * 72.0 * scale)
Cout	new_font_pts = nint( abs(csize) * 72.0 * 1.5 * scale)
	if((new_font_pts .ne. ifont_pts) .and. 
     +	    (new_font_pts .gt. 0)) then
C have to resize font:
		ifont_pts = new_font_pts
	end if
C
	  call ps_exp_write(x, y, num_ch, string, orien, 
     +			ipst_file, xp0, yp0, scale, ifont_pts)
	return
	end
C Following generate Postscript code from plot 10 calls.
C ---------------------------------------------------------
	subroutine my_ps_newpn(ipen, ipst_file, updown)
	integer rgb(1:3, 16)
	save rgb
	integer updown
C 	"Black", "Red", "Green", "Yellow", 
C	"Blue", "Magenta","Cyan", "White",
C	"Gray", "PeachyPink", "Aqua", "YellowOrange",
C	"RoyalBlue", "PurplePink", "PaleGreen", "Brown"
	data rgb/ 0,0,0,  255,0,0, 0,255,0, 255,255,0,
     +	  0,0,255, 255,0,255, 0,255,255, 255,255,255,
     +	  127,127,127, 255,218,185, 50,191,193, 250,250,210,
     +	65,105,225, 137,104,205, 115,222,120, 165,42,42 /
	if( ipen .gt. 16) then
		ipen = 1
	end if
	if( (updown .eq. 2) .or. (updown .eq. 3) ) then 
C stroke no matter whether pen is up or down, 
C otherwise the changes will apply to segments already drawn!
		write(ipst_file,*)' stroke'
	end if
C change pen color or width
	if( ipen .gt. 0)then 
		write(ipst_file,*)rgb(1,ipen)/255.0, 
     +		  rgb(2,ipen)/255.0,rgb(3,ipen)/255.0, 
     +		' setrgbcolor' 
	else if( ipen .lt. 0) then ! linewidth
		write(ipst_file,*)-ipen,' setlinewidth'
        else
		gray = 0.0 ! Black
	        write(ipst_file,*)gray, ' setgray' 
	end if
      return
      end 
C --------------------------------------
      subroutine my_ps_plot(x, y, updown, ipst_file, xp0, yp0,scale,
     +		last_pen)
      real x, y 
      real xpt, ypt
      integer updown, last_pen
C 
	xpt = xp0 + scale * x * 72 ! convert to points (1/72 of inch unit)
	ypt = yp0 + scale * y * 72
        if( updown .eq. 2) then ! just do a line to xy 
		write(ipst_file,'( 2(f11.3,1x), " d" )') xpt,ypt 
		last_pen = 2
        else if(updown .eq. 3) then ! stroke (in case unfinished) and move to xy 
		write(ipst_file,'( 2(f11.3,1x), " m" )') xpt,ypt 
		last_pen = 3
	else if( updown .eq. -3) then ! do above, then shift origin
		write(ipst_file,'( 2(f11.3,1x), " m" )') xpt,ypt 
		xp0 = xp0 + x * 72 * scale
		yp0 = yp0 + y * 72 * scale
		last_pen = 3
        else if( updown .eq. 0) then ! just redefine origin
		xp0 = xp0 + x * 72 * scale
		yp0 = yp0 + y * 72 * scale
        else if( updown .eq. -2) then ! just do a line to xy , redefine origin
		write(ipst_file,'( 2(f11.3,1x), " d" )') xpt,ypt 
		xp0 = xp0 + x * 72 * scale
		yp0 = yp0 + y * 72 * scale
		last_pen = 2
        else if( updown .eq.1) then ! move or draw
		if( last_pen .eq. 2) then
			write(ipst_file,'( 2(f11.3,1x), " d" )') xpt,ypt 
		else if( last_pen .eq. 3) then
			write(ipst_file,'( 2(f11.3,1x), " m" )') xpt,ypt 
		end if
        else if( updown .eq.-1) then ! move  and redefine origin
		if( last_pen .eq. 2) then
			write(ipst_file,'( 2(f11.3,1x), " d" )') xpt,ypt 
		else if( last_pen .eq. 3) then
			write(ipst_file,'( 2(f11.3,1x), " m" )') xpt,ypt 
		end if
		xp0 = xp0 + x * 72 * scale
		yp0 = yp0 + y * 72 * scale
 	else if( updown .eq. 998) then ! show the page, close file
	        write(ipst_file,*)' stroke' ! in case some line left to draw 
C BEWARE, following line will screw up EPSF
        	write(ipst_file,*)' showpage'
		close(ipst_file)
	end if
	return
	end 
C --------------------------------------------- 
      subroutine my_ps_symbl(x, y, nchar, string, rotang, ipst_file,
     +		xp0, yp0, scale, ifnt_pts)
      real x, y, rotang 
      integer nchar
      integer xpt, ypt
      character string*(*), sh_str*11
C plot a string.
      xpt = nint(xp0 + scale * x * 72) ! convert to points (1/72 of inch unit)
      ypt = nint(yp0 + scale * y * 72)
      write(ipst_file,'(2(i8,1x)," m" )')xpt,ypt  
	if( rotang .ne. 0.0 ) then
		write(ipst_file, 90)xpt, ypt
90		format(i8, 1x, i8, ' translate')
		write(ipst_file, 100)rotang
100		format(f6.1,1x,'rotate')
	end if
	if( nchar .lt. 0) then ! x,y is pos of right side of string
	  nc = -nchar
	  sh_str(1:10) = '    my_rsc'
	  write(sh_str(1:3),'(i3)')ifnt_pts
      write(ipst_file,*)'(' // string(1:nc) // ')' // sh_str(1:10)
      write(ipst_file,*)'(' // string(1:nc) // ')' // ' show grestore' 
	else
	  nc = nchar
	  sh_str(1:11) = '    my_show'
	  write(sh_str(1:3),'(i3)')ifnt_pts
	  write(ipst_file,*)'(' // string(1:nc) // ')' // sh_str
	end if
	if( rotang .ne. 0.0 ) then
		write(ipst_file, 100)-rotang
		write(ipst_file, 90)-xpt, -ypt
	end if
      return
      end 
C ----------
C code for circle, clipped to window
	subroutine my_ps_circle(x, y, radius, w, ipst_file, scale)
	real x, y, w(4)
C
	ixl = w(1) * 72 * scale
	ixr = w(3) * 72 * scale
	iyb = w(2) * 72 * scale
	iyt = w(4) * 72 * scale
	ixc = x * 72 * scale
	iyc = y *72 * scale
	irad = radius * 72 * scale
C save graphics state so can restore after circle drawn
	write(ipst_file,*)'gsave '
C set current path to be window, and define new clip region
	write(ipst_file,*)' newpath ',ixl,iyb,' moveto'
	write(ipst_file,*)ixr,iyb,' lineto'
	write(ipst_file,*)ixr,iyt,' lineto'
	write(ipst_file,*)ixl,iyt,' lineto'
	write(ipst_file,*)' closepath clip'
C Now use arc to make circular path, clip and draw,
C assuming line weight and color have been set before calling this 
C code, and restore graphics state.
	write(ipst_file,*)'newpath ',ixc, iyc, irad,' 0 360 arc '
        write(ipst_file,*)' clip stroke grestore '
	return
	end
C ---------------------------------
	subroutine ps_comment(ipst_file,comment)
C Use this to add comments to ps file, to delineate maps, for example
	integer ipst_file
	character*(*) comment
C
	write(ipst_file,*)'% ',comment
	return
	end

C --------------------------------------------------------------------
      subroutine ps_write(x, y, nchar, string, rotang, ipst_file,
     +		xp0, yp0, scale, ifnt_pts, itype)
C generalization of symbl
      real x, y, rotang 
      integer nchar
      integer xpt, ypt
      character string*(*), sh_str*11
C plot a string.
      xpt = nint(xp0 + scale * x * 72) ! convert to points (1/72 of inch unit)
      ypt = nint(yp0 + scale * y * 72)
      write(ipst_file,'(2(i8,1x)," m" )')xpt,ypt  
	if( rotang .ne. 0.0 ) then
		write(ipst_file, 90)xpt, ypt
90		format(i8, 1x, i8, ' translate')
		write(ipst_file, 100)rotang
100		format(f6.1,1x,'rotate')
	end if
	  nc = nchar
	if( itype .eq. -1) then ! x,y is pos of right side of string
	  sh_str(1:10) = '    my_rsc'
	  write(sh_str(1:3),'(i3)')ifnt_pts
      write(ipst_file,*)'(' // string(1:nc) // ')' // sh_str(1:10)
      write(ipst_file,*)'(' // string(1:nc) // ')' // ' show grestore' 
	else if( itype .eq. 0) then ! x,y is pos of left side of string
	  sh_str(1:11) = '    my_show'
	  write(sh_str(1:3),'(i3)')ifnt_pts
	  write(ipst_file,*)'(' // string(1:nc) // ')' // sh_str
	else if( itype .eq.1) then ! x,y is pos of center of string
	  sh_str(1:10) = '    my_csc'
	  write(sh_str(1:3),'(i3)')ifnt_pts
      write(ipst_file,*)'(' // string(1:nc) // ')' // sh_str(1:10)
      write(ipst_file,*)'(' // string(1:nc) // ')' // ' show grestore' 
	end if
	if( rotang .ne. 0.0 ) then
		write(ipst_file, 100)-rotang
		write(ipst_file, 90)-xpt, -ypt
	end if
      return
      end 
C ---------------------------
      subroutine ps_exp_write(x, y, nchar, string, rotang, ipst_file,
     +		xp0, yp0, scale, ifnt_pts)
C generalization of symbl, with the addition of sub and superscripts...
C subscripts are bracketed by @, and superscripts are bracketed by ^,
C so these characters will not be printed.
C thus meters squared per second would be m^2^s^-1^, etc
C nchar should include the @ or ^ characters!
      real x, y, rotang 
      integer nchar
      integer xpt, ypt
      character string*(*), out_str*80
	character sh_str*11, sub_str*12, sup_str*14
	logical sub_writing, super_writing
C plot a string.
      xpt = nint(xp0 + scale * x * 72) ! convert to points (1/72 of inch unit)
      ypt = nint(yp0 + scale * y * 72)
      write(ipst_file,'(2(i8,1x)," m" )')xpt,ypt  
	if( rotang .ne. 0.0 ) then
		write(ipst_file, 90)xpt, ypt
90		format(i8, 1x, i8, ' translate')
		write(ipst_file, 100)rotang
100		format(f6.1,1x,'rotate')
	end if
	nout = 0
	sub_writing = .false.
	super_writing = .false.
	sh_str(1:11) = '    my_show'
	write(sh_str(1:3),'(i3)')ifnt_pts
	sub_str(1:12) = '    sub_show'
	write(sub_str(1:3),'(i3)')ifnt_pts
	sup_str(1:14) = '    super_show'
	write(sup_str(1:3),'(i3)')ifnt_pts
	do i = 1, nchar
		if(string(i:i) .eq. '@') then
		   if(sub_writing) then ! close of subscript
      write(ipst_file,*)'('//out_str(1:nout)//')'// sub_str
		      nout = 0
		      sub_writing = .false.
		   else if(super_writing) then ! close of superscript
	      write(ipst_file,*)'('//out_str(1:nout)//')'//sup_str
		      nout = 0
		      super_writing = .false.
		   else if(nout .gt. 0) then ! regular
	      write(ipst_file,*)'('//out_str(1:nout)//')'//sh_str
		      nout = 0
		      sub_writing = .true.
		   else
			nout = 0
			sub_writing = .true.
		   end if
		else if(string(i:i) .eq. '^') then
		   if(super_writing) then ! close of superscript
	      write(ipst_file,*)'('//out_str(1:nout)//')'//sup_str
		      nout = 0
		      super_writing = .false.
		   else if(sub_writing) then ! close of subscript
      write(ipst_file,*)'('//out_str(1:nout)//')'//sub_str
		      nout = 0
		      sub_writing = .false.
		   else if(nout .gt. 0) then ! regular
	      write(ipst_file,*)'('//out_str(1:nout)//')'//sh_str
		      nout = 0
		      super_writing = .true.
		   else
			nout = 0
			super_writing = .true.
		   end if
		else
		   nout = nout + 1
		   out_str(nout:nout) = string(i:i)
		end if
	end do
	if( nout .gt. 0) then ! some regular text left to write
	      write(ipst_file,*)'('//out_str(1:nout)//')'//sh_str
	end if
	if( rotang .ne. 0.0 ) then
		write(ipst_file, 100)-rotang
		write(ipst_file, 90)-xpt, -ypt
	end if
      return
      end 
C **********
      function inside_box(pointx,pointy,w)
C Returns a location code for point, relative to window.
C Lower left corner of window is (w(1),w(2)), upper right 
C is (w(3),w(4)). 
C     1001/9  1000/8  1010/10    above the window 
C     0001/1  0000/0  0010/2     left,window,right
C     0101/5  0100/4  0110/6     below the window 
      dimension w(4)
      inside_box = 0
      if(pointx.lt.w(1))then
              inside_box = inside_box + 1 
      else if(pointx.gt.w(3))then 
              inside_box = inside_box + 2 
      endif 
      if(pointy.lt.w(2))then
              inside_box = inside_box + 4 
      else if(pointy.gt.w(4))then 
              inside_box = inside_box + 8 
      endif 
      return
      end 

