	program disc_radar_check
C 9 June 2005 - Version for radar files copied to disc from tape in 
C fortran-binary format. Also write average track...
C	Version for thor ... all mergedtape stuff commented out
C because code for those not avail on thor. Version on gaea CAN handle those.
C Read MARS radar system tapes and derive some statistics.
C The equations are from tech memo and radar conf paper by J. Testud.
C use biglib subroutine anglecor for angle corrections
C approximate azimuthal resolutions:
C 2 Dec 1992 - mod to follow latest code from lee and testud, ncar
C	uses lagrange multipliers and cos(2 phi)...
C 19 Oct 1993 - mod again to follow eqns in draft of Testud, Hildebrand, and
C Lee (2-21-93)
C Changed to new RAMS file format 12 May 1994
C Fixed errors in use of mu, mu1 discovered after proofreading Testud et al
C 28 Feb 1995.
C	Changed to tapeheader common block to include dual_prf flags
C	Also replaced xnyq with xniqta
C	25 March 2003 P Dodge
	parameter (dmax_ta = 1.0, dmax_lf = 2.0)
C
	include "hrd_radar_common_blocks.f"
C
      REAL SECONDS,STIME,ETIME,TIME1,TIME2,
     +     AZMCOR,ELCOR,PCOR,RCOR,DCOR
	logical found_tail, want_port
 	integer maxpts, badz
	integer taplu, irdwr, tape, outlu, ierr, method
	character*32 namram, namout, yesno*1,string*5
	character*32 time_stamp ! for writing out current time
	logical power_wt, searching
	Character iflid*8, istnm*12
	real mu, mu1, mu2	! Lagrange multipliers 2 dec 1992
	parameter( max_pts = 3000 ) ! i hope thats way too big
	real phi_n(max_pts), vel_n(max_pts), rng_n(max_pts)
        real phi_display(max_pts),vel_display(max_pts)
        real radiitasim(max_hrd_dim)
        real rres(14),sumrres(14),sumrres2(14)
        real wvres(14)
        integer nvres(14)
        real sumvres(14),sumvres2(14)
	parameter ( max_sweeps = 600 )
	real resid_Vg(max_sweeps), resid_Rg(max_sweeps) 
	real tilt_cor(max_sweeps)
	parameter( max_iter = 100)
C
	integer plotter
	character*56 radar_fn
	logical plot_swps, plot_time
C
	integer idataflag, iatten
C
        do i=1,14
         wvres(i)=0
         nvres(i)=0
         sumvres(i)=0
         sumvres2(i)=0
         sumrres(i)=0
         sumrres2(i)=0
        enddo
        write(6,*)'read parameters in?'
c        read(5,'(a1)')yesno
        ireadlu=82
        open(ireadlu,file='angleparametersin')
c        if(yesno.eq.'y'.or.yesno.eq.'Y')then
c         write(6,*)'enter input file name'
c         read(5,'(a32)')namout
c         ireadlu=82
c         open(ireadlu,file=namout)
c        else
c         ireadlu=5
c        endif
        open(72,file='check rg')
        open(65,file='postscriptnames')
	do i = 1, max_sweeps
		resid_Vg(i) = 0.0
		resid_Rg(i) = 0.0
	end do
C
	deg2rad = acos(-1.0) / 180.0
	rad2deg = 1.0 / deg2rad
	half_beam_ta = 0.8 ! degrees, vertical
	half_beam_lf = 2.05 ! degrees, vertical
	beam_wid = 2.0 * half_beam_ta
C 
C
c
c drift below is always set to positive to keep as defined in paper
c phi changed around to reflect paper
c Jan 31, 2011
c
	kindradar = 2 ! tail
	PCOR = 0.0
	DCOR = 0.0
	RCOR = 0.0
	AZMCOR = 0.0
	ELCOR = 0.0
        HCOR = 0.0
        DRG = 0.0
	rollmax = 90.0
	luno = 1
        iaftyes=1
        iforeyes=1
C
	irdwr = 0 	! tape is read only
	iprint = 1	! for error messages
	outlu = 22
	lu2 = 23 ! for nadir file
        lu3 = 44 ! for minmeanmax file
	ipst_file = lu2 + 1 ! for Postscript, if we want...
        write(6,*)'all(0), aft(1), or fore(2) sweeps'
        read(ireadlu,*)isweeptype
        write(6,*)'are you computing tilt and range delay (0)'
        write(6,*)'or are you computing drift, pitch and roll?'
        write(6,*)'you should do tilt and range delay first'
        read(ireadlu,*)itiltrdel
        if(isweeptype.eq.0)then
         elevmin=-90.
         elevmax=90.
        elseif(isweeptype.eq.1)then
         elevmin=-10.
         elevmax=90.
        elseif(isweeptype.eq.2)then
         elevmin=-90.
         elevmax=10.
        else
         elevmin=-90.
        elevmax=90.
        endif
	open(1, file = '/dev/tty')
c        write(6,*)'enter tilt error to test'
c        read(ireadlu,*)elevtest
c        write(6,*)'enter drift error to test'
c        read(ireadlu,*)drifttest
c        write(6,*)'enter pitch error to test'
c        read(ireadlu,*)pitchtest
c        write(6,*)'enter azm error to test'
c        read(ireadlu,*)azmtest
c        write(6,*)'enter rdel to test (km)'
c        read(ireadlu,*)rdeltest
c        rdeltest=rdeltest*1000.
        elevtest=0.0
        drifttest=0.0
        pitchtest=0.0
        azmtest=0.0
        rdeltest=0.0
	write(6,*)' Apply corrections? '
	read(ireadlu,'(a)')yesno
	if( (yesno .eq. 'y') .or. (yesno .eq. 'Y') ) then
	   write(6,*)' enter pitch cor: '
	   read(ireadlu,*)pcor
           if(itiltrdel.eq.0)pcor=0.
	   write(6,*)' enter drift cor: '
	   read(ireadlu,*)dcor
           if(itiltrdel.eq.0)dcor=0.
	   write(6,*)' enter roll cor: '
	   read(ireadlu,*)rcor
           if(itiltrdel.eq.0)rcor=0
	   write(6,*)' enter el cor: '
	   read(ireadlu,*)elcor1
           read(ireadlu,*)elcor2
c           if(itiltrdel.eq.0)elcor=0.
           write(6,*)' enter height cor (m): '
           read(ireadlu,*)hcor
c           if(itiltrdel.eq.0)hcor=0
           hcor=0.
           write(6,*)' enter ground speed correction '
           read(ireadlu,*)vgscor
           if(itiltrdel.eq.0)vgscor=0
           vgscor=0
           write(6,*)' enter range correction '
           read(ireadlu,*)rangcor
           if(itiltrdel.eq.0)rangcor=0
           rangcor=0
	end if
	nsweep = 0
C get tape, and  output file
C  From Nancy Griffin's documentation
C	openradarfile(nameradarfile,lut,lup,ierr)
C     nameradarfile(character) - name of disc file to be opened.
C    lut(integer) - logical unit number of disc file, for the open statement.
C     lup(integer) - lu for messages, either 1 or 6.
C     ierr(integer) - lu for error messages.
C
C	radardiscread1(LUT,KINDRADAR,IHEADERFLAG,IDATAFLAG, IERR)
C	radardiscrewind(lut)
C 2) You may search for times and sweeps with:
C     discsearch(lut,kindradar,iop,rkey,ierr)
C      This subroutine reads the SIGMET format data and searches for a
C     specified sweep number or a specified time.  It positions the disc at
C     the beginning he specified sweep number or the specified time.
C     lut - disc logical unit number, from open    (integer)

	write(6,*)' Radar data directory (including trailing slash): '
	read(ireadlu,'(a)')radar_fn
	tape = 20
        lu = tape
        call open_rvp8_file(radar_fn, lu, lu_errors, ierr)
c	call openradarfile(radar_fn, tape,1,ierr)
C	call tapeopen(taplu, irdwr, tape)
C	CALL RADARTAPEREWIND(tape)
C	call tapecontrol(tape, 2,1) ! backspace one file

	IHEADERFLAG=0 !DON'T WANT BIG HEADER INFO
	IDATAFLAG = 6   ! DBZ ARRAY (BIT 2= ON), vel array bit1 = on.
C
	write(6,*)' Enter output file name :'
	read(ireadlu,'(a32)')namout
	open(unit = outlu, file = namout, form = 'unformatted')
	open(unit = lu2, file = 'nadir.dat', form = 'formatted')
        open(unit = lu3, file = 'minmeanmax.dat', form = 'formatted')
	write(6,*)' enter angle to examine (vertical +- this):'
	read(ireadlu,*)wedge
	azbeg = 180 - wedge
        wedgetestlow = azbeg + 5.
	azend = 180 + wedge
        wedgetesthigh = azend - 5.
        nrays=0
        write(6,*)'outlu,wedge = ',outlu,wedge
        write(6,*)'namout = ',namout
	write(outlu)wedge
C11	format(1x,' Rays searched for sectors within ',f4.1,' of 180.')
C
	write(6,*)' enter range delay correction (km) for tail: '
c        read(ireadlu,*)rdelcor
c        rdelcorta=0
	read(ireadlu,*)rdelcorta
	write(outlu)rdelcorta
	write(outlu)pcor,dcor,rcor, azmcor, elcor1,elcor2,
     +              hcor,vgscor,rangcor
        write(6,*)'rdelcorta = ',rdelcorta
        write(6,*)'pcor,dcor,rcor,azmcor,elcor = ',pcor,dcor,rcor,
     +             azmcor,elcor
c        pause
C Hardwire these as sugg by wc lee 7 mar 1995. should change code
C to read all the magic #'s from a file
Cout	write(6,*)' enter Lagrangian mults mu, mu1 and mu2:'
Cout	read(ireadlu,*)mu, mu1, mu2
	mu = 0.01
	mu1 = 100.0
	mu2 = 1.0
        mu1 = mu
	write(outlu)mu, mu1, mu2
Cout	write(6,*)' enter expected std of C, B2, w and pitch: '
Cout	read(ireadlu,*)stdC, stdB2, stdw, stdbeta
	stdC = 10.0
	stdB2 = 0.1
	stdw = 0.1
	stdbeta = 0.2
	write(outlu)stdC, stdB2, stdw, stdBeta
C
	write(6,*)' enter start time (hhmm) '
	read(ireadlu,'(2i2)')ihs,ims
	time_start = 3600.0 * ihs + ims * 60.0
	write(6,*)' enter end time (hhmm) '
	read(ireadlu,'(2i2)')ihe,ime
	time_end = 3600.0 * ihe + 60.0 * ime
	write(outlu)time_start, time_end
C
C Following code commneted out, until code added to implement its wishes!
c	write(6,320)
c320	format(1x,'If f/ast scan want none(0), forward only(1),',/,
c     +		1x,'aft only (2), or both (4) ?')
c	read(ireadlu,*)ifast_type
	ifast_type = -1 ! TEMPORARY !!!!!!!!!!!!!!!!!!!!!!!!!!
	write(outlu)ifast_type
C
        plot_time = .false.
        plot_swps = .false.
	write(lu2,222)
	write(lu2,*) 'tilt_mean, tilt_cor, Vh_mean,',
     +  ' alt_mean, del_Vh, del_w, d_pitch, d_rlaz,  d_drift,',
     +	' del_h'
	write(6,*)' Want to plot d Vr and d Rng for single sweeps? '
	read(ireadlu,'(a)')yesno
	if( (yesno.eq.'y') .or. (yesno.eq.'Y') )then
	  plot_swps = .true.
	end if
	write(6,*)' Want to plot time series of d Vr and d Rng? '
	read(ireadlu,'(a)')yesno
	if( (yesno.eq.'y') .or. (yesno.eq.'Y') )then
	  plot_time = .true.
	end if
	if ( plot_time .or. plot_swps ) then
C get plotter
	  write(6,104)
104       format(1x,'Pick your device. 1- Tektronix'/,4x,
     +        4x,'2 - X-Window'/,4x,
     +	      4x,'51 - laser III '/,
     +        4x,'999 - Ono Sendai. You want _')
	  read(ireadlu,*)plotter
	  if(plotter.eq.999)stop 'Turing police have been alerted.' 
	end if
C space to start time:
	iswp1 = -1
	time = -1.0
        rkey = time_start - 10.
        iop = 2
        if(rkey.lt.0.)rkey = 1.
        write(6,*)'calling rvp8_search'
	call rvp8_search(lu,kindradar,iop,rkey,ierr)
        write(6,*)'called rvp8_search'
	do while( time .lt. time_start)
           write(6,*)'calling radar_rvp8_read'
           ntasweepbefore=ntasweep
 2900	   CALL radar_rvp8_read(tape,KINDRADAR,IHEADERFLAG,
     +			IDATAFLAG,IERR)
                write(6,*)'A roll,pitch,drift = ',roll,pitch,drift
                write(6,*)'A elev,ra,gs,azm = ',elev,ra,gs,azm
           write(6,*)'called radar_rvp8_read'
           write(6,*)'ntasweep = ',ntasweep
c          WRITE(6,'(3I2.2)')IH,IM,IS
	  if(ierr .lt. 0) then
	   if( ierr .gt. -2 ) then
		write(6,*) ' taperead error ',ierr,' will try next.'
	   else
		write(6,*)ierr, ' eot.'
		go to 2900
	   end if
	  end if
	end do
C write out flight id
c	call cftime(time_stamp)
        time_stamp = 'time stamp unavailable'
	write(outlu)flightid, time_stamp
        nrays = 0
	nsweeps = 0
        newsweep = 0
C do one sweep, use fact that tail always rotates same direction:
        write(6,*)'one'
c        pause
100	az_t = -999.0 
C read data until azbeg
        write(6,*)'newsweep,nsweeps = ',newsweep,nsweeps
c        pause
        if(newsweep.eq.1.or.nsweeps.eq.0)then
         vg_res_mean = 0.0
         vg_res2_sum = 0.0
         vg_res_max = -1000.
         vg_res_min = 1000.
	 tilt_mean = 0.0
         tilt_min = 90.
         tilt_max = -90.
	 Vh_mean= 0.0
	 alt_mean = 0.0
	 dop_mean = 0.0
         azm_mean = 0.0
         azm_min = 360.
         azm_max = 0.
         aztest_mean = 0.
         aztest2_mean = 0.
	 roll_mean = 0.0
	 roll_max = -90.0
	 roll_min = 90.0
	 pitch_mean = 0.0
	 pitch_max = -90.0
	 pitch_min = 90.0

	 drift_mean = 0.0
	 drift_max = -90.0
	 drift_min = 90.0
         write(6,*)'calling zero_sums'
	 call zero_sums(a, b, c, d, e, f, g, h, p, q,
     +		r, s, t, rp, sp, tp, zp, icount)
         newsweep=0
         iaftyes=0
         iforeyes=0
         write(6,*)'returned from zero_sums and ntasweep = ',ntasweep
c         pause
         if(nrays.gt.0.or.nsweeps.eq.0)nsweeps = nsweeps +1 
         write(6,*)'reset nsweeps to ',nsweeps
c         pause
        endif
        nrays = 0
        do while(newsweep.eq.0)
	 if(az_t.lt.azbeg .or. az_t.gt.azend)then
                itimecount=0
c                write(6,*)'calling radar_rvp8_read'
                elevbefore = elev
                azmbefore = azm
                ntasweepbefore=ntasweep
 901		CALL radar_rvp8_read(tape,KINDRADAR,IHEADERFLAG,
     +			IDATAFLAG,IERR)
                write(6,*)IH,IM,IS,roll
                write(6,*)'B roll,pitch,drift = ',roll,pitch,drift
                write(6,*)'B elev,ra,gs,azm = ',elev,ra,gs,azm
                if(elevbefore.gt.1.)iforeyes=1
                if(elevbefore.lt.-1.)iaftyes=1
c                newsweep=0
                if(ntasweepbefore.ne.ntasweep)then
                 write(6,*)'B newsweep opened and elev = ',elev
                 write(6,*)'B newsweep,iaftyes,iforeyes,nrays = ',
     +                      newsweep,iaftyes,iforeyes,nrays
                 if(isweeptype.eq.0.and.iaftyes.eq.1.and.
     +              iforeyes.eq.1)then
                  newsweep=1
                  iaftyes=0
                  iforeyes=0
                 elseif(isweeptype.eq.1.and.iaftyes.eq.1)then
                  newsweep=1
                  iaftyes=0
                  iforeyes=0
                 elseif(isweeptype.eq.2.and.iforeyes.eq.1)then
                  newsweep=1
                  iaftyes=0
                  iforeyes=0
                 endif
                 write(6,*)'B newsweep,iaftyes,iforeyes,nrays = ',
     +                      newsweep,iaftyes,iforeyes,nrays
c                 pause
                endif
c                if(newsweep.eq.1)go to 90292
c                write(6,*)'returned from radar_rvp8_read'
c          WRITE(6,'(3I2.2)')IH,IM,IS
		if(ierr .lt. 0) then
		   if( ierr .gt. -2 ) then
		     write(6,*) ' taperead error ',ierr,' try next.'
		     go to 100
		   else
		     write(6,*)ierr, ' eot.'
		     go to 901
		   end if
		else if( time .gt. time_end) then
                   if(itimecount.gt.20)then
			write(6,*)' passed end time.'
			go to 900
                   else 
                     itimecount=itimecount+1
                     go to 901
                   endif
		end if
                if(newsweep.eq.1)then
                 write(6,*)'I got here 1'
c                 pause
                endif
cc the values ending in sim are the simulated absolutely correct values
cc other values are the measured and then measured plus correction
                elevsim=elev+elevtest
                pitchsim=pitch+pitchtest
                driftsim=drift+drifttest
                azmsim=azm+azmtest
                rasim=ra
                rollsim=roll
                do kk=1,1024
                 if(radiita(kk).gt.0.)then
c Oct 29 2013 Changed to 0 from +rdelcorta
                  radiitasim(kk)=radiita(kk)+rdeltest+rdelcorta
                 else
                  radiitasim(kk)=-999.
                 endif
                enddo
                write(6,*)'1 roll,pitch,drift = ',roll,pitch,drift
                write(6,*)'1 elev,ra,gs,azm = ',elev,ra,gs,azm
		roll = roll + rcor
		pitch = pitch + pcor
                pitchsim=pitch
		drift = drift + dcor
                driftsim=drift
                if(elev.lt.0..and.isweeptype.eq.0)then
                 elev = elev - elcor1 + elcor2
                else
  		 elev = elev + elcor1 + elcor2
                endif
                elevsim=elev
                elevsigntest=elev*elevbefore
                ra = ra + hcor
                gs = gs + vgscor
		azm = azm + azmcor
                azmsim = azm
		az_t = azm + roll
                write(6,*)'2 roll,pitch,drift = ',roll,pitch,drift
                write(6,*)'2 elev,ra,gs,azm = ',elev,ra,gs,azm
         write(6,862)ih,im,is,azm,elev
 862	 format(3i2.2,2f12.2)
         endif
C
	if( iswp1 .eq. -1) then
		iswp1 = ntasweep ! lazy way to save first good sweep
		ihs = ih
		ims = im
		iss = is
	end if
C work on data between azbeg and azend
        write(6,*)'ntasweep,ntasweepbefore = ',ntasweep,ntasweepbefore
        write(6,*)'right before newsweep test and newsweep = ',newsweep
c        pause
	if( nsweeps .gt. max_sweeps) then
		write(6,*)' Exceeded ', max_sweeps, 'sweeps.'
		go to 900
	end if
d	write(6,*)'azm, roll: ',azm,roll, ' ra: ',ra
d	pause 'pausing'
	write(6,321) nsweeps, ntasweep,ih,im,is
321	format(' working on sweep # ',i4,' (',i4,') at ',3i2.2)
C		>>>>>>>>>>>>>>>>>>>>>>>>	
        if(newsweep.eq.1)then
         write(6,*)'I got here 2 and az_t = ',az_t
c         pause
        endif
 	if(az_t.ge.azbeg.and.az_t.le.azend.and.newsweep.ne.1)then
         if(isweeptype.eq.1.and.elev.lt.0.)then
          endazm = azm
         endif
         if(isweeptype.eq.2.and.elev.gt.0.)then
          endazm = azm
         endif
c     +   iaftyes.eq.0.or.iforeyes.eq.0 )
c       write(6,*)' calling find_ground. ih,im,is,az_t = ',
c     +   ih,im,is,az_t
c         write(6,*)'iaftyes,iforeyes = ',iaftyes,iforeyes
c          pause
	  call find_ground_old(deg2rad, beam_wid,
     +		rs_th, rs_m, dBz_max, ibeg, Ng2,
     +    elevsim,pitchsim,azmsim,rollsim,rasim,radiitasim)
c       write(6,*)'azm,roll',azm,roll,'rs_th, rs_m',rs_th, rs_m
c       write(6,*)'ibeg, ng2', ibeg, Ng2
c          pause
c          rs_th=rs_th+rangcor
          if(elev.gt.-90..and.elev.lt.-10.)then
           if(isweeptype.eq.2)ibeg=0
          elseif(elev.gt.10..and.elev.lt.90.)then
           if(isweeptype.eq.1)ibeg=0
           write(6,*)'ibeg,isweeptype = ',ibeg,isweeptype
          else
           ibeg=0
          endif
       write(6,*)'azm,roll',azm,roll,'rs_th, rs_m',rs_th, rs_m
       write(6,*)'ibeg, ng2', ibeg, Ng2
       if(ibeg.gt.0)then
        write(6,*)'using data and azm,elev = ',azm,elev
                write(6,*)'3 roll,pitch,drift = ',roll,pitch,drift
                write(6,*)'3 elev,ra,gs,azm = ',elev,ra,gs,azm
       		   call get_residual(ibeg, xniqta, Vg_res, Vr,
     +             elevsim,driftsim,pitchsim,azmsim,rollsim)
c         write(6,*)'ibeg,vg_res,dbz(ibeg) = ',
c     +       ibeg,vg_res,dbzbuffer(ibeg)
                   if(abs(Vg_res).gt.15.)then
                    ibeglow=ibeg-10
                    ibeghigh=ibeg+10
                    if(ibeglow.lt.1)ibeglow=1
                    if(ibeghigh.gt.max_hrd_dim)ibeghigh=max_hrd_dim
		    write(6,323)(dbzbuffer(ji),ji=ibeglow,ibeghigh)
 323		    format(21f6.1)
                    go to 322
                   endif
       endif
          if(isweeptype.eq.0)then
           iadd=1
          elseif(isweeptype.eq.1.and.elev.lt.0)then
           iadd=1
          elseif(isweeptype.eq.2.and.elev.gt.0)then
           iadd=1
          else
           iadd=0
          endif
	  if ( (dBz_max .gt. 0.0) .and. (ibeg .gt. 0) .and.
     +         iadd.eq.1.and.
     +		(ibeg + Ng2 .le. max_hrd_dim) ) then ! --> --> --> --> --> --> --> -->
		nrays = nrays + 1
                aelev=abs(elev)
		tilt_mean = tilt_mean + aelev
                if(elev.lt.tilt_min) tilt_min = aelev
                if(elev.gt.tilt_max) tilt_max = aelev
		Vh_mean = Vh_mean + gs
		alt_mean = alt_mean + ra
                azm_mean = azm_mean + az_t
                aztest = az_t - 180.
                aztest_mean = aztest_mean + aztest
                aztest2_mean = aztest2_mean + aztest*aztest
                write(6,*)'nrays,tilt_mean,aelev = ',
     +                     nrays,tilt_mean,aelev
                write(6,*)'nrays,aztest,aztest_mean,aztest2_mean = ',
     +                     nrays,aztest,aztest_mean,aztest2_mean
                if(az_t.gt.azm_max) azm_max = az_t
                if(az_t.lt.azm_min) azm_min = az_t
		roll_mean = roll_mean + roll
		if(roll .gt. roll_max) roll_max = roll
		if(roll .lt. roll_min) roll_min = roll
		drift_mean = drift_mean + drift
		if(drift .gt. drift_max) drift_max = drift
		if(drift .lt. drift_min) drift_min = drift
		pitch_mean = pitch_mean + pitch
		if(pitch .gt. pitch_max) pitch_max = pitch
		if(pitch .lt. pitch_min) pitch_min = pitch
                rakm = ra/1000.
		do i = ibeg, ibeg + Ng2*2
                 heightdiff = abs(rakm - radiitasim(i))
                 if(heightdiff.lt..000001)then
c turning off the ring removal part
c                  if(heightdiff.lt.1.)then
                  write(6,*)'eliminating ring point'
                  write(6,*)'i,heightdiff,ra,radiita(i) = ',
     +             i,heightdiff,ra,radiitasim(i)
                  go to 322
                 endif
		  if( velbuffer (i) .gt. -888.8 ) then ! ***************
C Difference between surface range from navigation and ground clutter
		   del_Rg = radiitasim(i)*1000.0 - rs_th 
                 write(72,*)'az_t,radiita,rs_th,del_Rg = ',
     +            az_t,radiita(i),rs_th,del_Rg
c fixed to reflect paper
C get residual doppler vel:
d	write(6,*)' call get_residual. i = ',i
                write(6,*)'4 roll,pitch,drift = ',roll,pitch,drift
                write(6,*)'4 elev,ra,gs,azm = ',elev,ra,gs,azm
		   call get_residual(i, xniqta, Vg_res, Vr,
     +             elevsim,driftsim,pitchsim,azmsim,rollsim)
                if(vg_res.gt.vg_res_max)vg_res_max = vg_res
                if(vg_res.lt.vg_res_min)vg_res_min = vg_res
                   vg_res_mean = vg_res_mean + Vg_res
                   vg_res2_sum = vg_res2_sum + Vg_res*Vg_res
                       azzi=az_t-azbeg+10.
                       numazzi=azzi/10.
c                       write(6,*)'az_t,azbeg,azzi,numazzi = ',
c     +                            az_t,azbeg,azzi,numazzi
                       nvres(numazzi)=nvres(numazzi)+1
                       wvres(numazzi)=wvres(numazzi)+1./(1.+2.*Ng2)
                       sumvres(numazzi)=sumvres(numazzi)+
     +                                 Vg_res/(1.+2.*Ng2)
                       sumrres2(numazzi)=sumrres2(numazzi)+
     +                 del_Rg*del_Rg/(1.+2.*Ng2)
                       sumrres(numazzi)=sumrres(numazzi)+
     +                                 del_Rg/(1.+2.*Ng2)
                       sumvres2(numazzi)=sumvres2(numazzi)+
     +                 Vg_res*Vg_res/(1.+2.*Ng2)
c                   write(6,*)'az_t,numazzi,nvres,sumvres,sumvres2 = ',
c     +                  az_t,numazzi,nvres(numazzi),sumvres(numazzi),
c     +                  sumvres2(numazzi)
c			write(6,*)'Vg_res,n,sum: ',Vg_res,nvres,sumvres
c                        pause
C get tilt_correction (my way...):
Cd	write(6,*)' call get_tilt_cor '
C		   call get_tilt_cor(xniqta, Vr, elev, 
C    +			max_iter,tilt_fix)
C		   tilt_cor(nsweeps) = tilt_cor(nsweeps) + tilt_fix
C accumulate for fit
d	write(6,*)' call acc_sums '
        write(lu3,215)ih,im,is,i,ibeg,Ng2,az_t,Vr,dbzbuffer(i),
     +    Vg_res,del_Rg
 215	format(1x,3i2.2,3i5,10f12.2)
                   if(elev.lt.0..and.isweeptype.eq.0)then
                    az_in = az_t + 180.
                    Vg_in = -Vg_res
                    write(6,*)'one'
                    del_Rg_in = -del_Rg
                   else
                    az_in = az_t
                    Vg_in = Vg_res
                    write(6,*)'two'
                    del_Rg_in = del_Rg
                   endif
c                   pause
		   call acc_sums(deg2rad, az_in, Vg_in, del_Rg_in,
c		   call acc_sums(deg2rad, az_in, Vg_in, del_Rg,
     +			a,b,c,d,e,f,g,h,p,q,r,s,t, rp, sp, tp, zp, Ng2,
     +                  icount)
		   index = icount
		   if( index .lt. max_pts)then
C save for later correction, display, and (not yet) filtering
		   	phi_n(index) = (az_t - 180) * deg2rad
                        phi_display(index) = az_in
          if(phi_display(index).gt.180.)
     +       phi_display(index) = phi_display(index) - 360.
          if(phi_display(index).lt.-180.)
     +       phi_display(index) = phi_display(index) + 360.
                        vel_display(index) = Vg_in
		   	vel_n(index) = Vg_res
		   	rng_n(index) = del_Rg
		   	dop_mean = dop_mean + velbuffer(i)
        az_in = az_in - 180.
        write(6,*)'i,n,phi,vg_res,del_rg,velbuffer = ',
     +    i,index,az_in,vg_in,del_rg,velbuffer(i)
		   end if
		 end if		! ***************************************
		end do
	   end if  ! <--<--<--<--<--<--<--<--<--<--<--<--<--<--<--<--<--<--<--
C	get another ray.
 322	   itimecount=0
c          write(6,*)'calling radar_rvp8_read 2'
c          write(6,*)'tape,kindradar = ',tape,kindradar
           elevbefore = elev
           azmbefore = azm
           ntasweepbefore = ntasweep
 902	   CALL radar_rvp8_read(tape,KINDRADAR,IHEADERFLAG,
     +			IDATAFLAG,IERR)
                write(6,*)'C roll,pitch,drift = ',roll,pitch,drift
                write(6,*)'C elev,ra,gs,azm = ',elev,ra,gs,azm
                if(elevbefore.gt.1.)iforeyes=1
                if(elevbefore.lt.-1.)iaftyes=1
c                newsweep=0
                if(ntasweepbefore.ne.ntasweep)then
                 write(6,*)'newsweep opened and elev = ',elev
                 write(6,*)'testing sweep'
                 write(6,*)'sweep numbers = ',ntasweepbefore,ntasweep 
                 write(6,*)'elevbefore,iforeyes.iaftyes = ',
     +            elevbefore,iforeyes,iaftyes                 
                 write(6,*)'C newsweep,iaftyes,iforeyes,nrays = ',
     +                      newsweep,iaftyes,iforeyes,nrays
                  if(isweeptype.eq.0.and.iaftyes.eq.1.and.
     +              iforeyes.eq.1)then
                  newsweep=1
                  iaftyes=0
                  iforeyes=0
                 elseif(isweeptype.eq.1.and.iaftyes.eq.1)then
                  newsweep=1
                  iaftyes=0
                  iforeyes=0
                 elseif(isweeptype.eq.2.and.iforeyes.eq.1)then
                  newsweep=1
                  iaftyes=0
                  iforeyes=0
                 endif
                write(6,*)'C newsweep,iaftyes,iforeyes,nrays = ',
     +                     newsweep,iaftyes,iforeyes,nrays
c       pause
                endif
c           if(ntasweepbefore.ne.ntasweep)then
c            write(6,*)'position 2, ntasweep,ntasweepbefore = ',
c     + ntasweep,ntasweepbefore
c            newsweep=1
c            if(elevbefore.gt.0)iforeyes=1
c            if(elevbefore.lt.0)iaftyes=1
c            pause
c           endif
c          write(6,*)'returned from radar_rvp8_read 2'
c          WRITE(6,'(3I2.2)')IH,IM,IS
	   if(ierr .lt. 0) then
	      if( ierr .gt. -2 ) then
		write(6,*) ' taperead error ',ierr,' try next.'
		go to 100
	      else
		write(6,*)ierr, ' eot.'
		go to 902
	      end if
	   else if( time .gt. time_end) then
                   if(itimecount.gt.20)then
			write(6,*)' passed end time.'
			go to 900
                   else 
                     itimecount=itimecount+1
                     go to 902
                   endif
	   end if
           elevsim=elev+elevtest
           pitchsim=pitch+pitchtest
           driftsim=drift+drifttest
           azmsim=azm+azmtest
           rollsim=roll
           rasim=ra
           do kk=1,max_hrd_dim
            if(radiita(kk).gt.0.)then
c Oct 29 2013 Changed to 0 from -rdelcorta
c             radiitasim(kk)=radiita(kk)+rdeltest+rdelcorta+
c     +                      rangcor*.001
             radiitasim(kk)=radiita(kk)+rdeltest+rdelcorta
            else
             radiitasim(kk)=-999.
            endif
           enddo
c           write(6,*)'radiita'
c           write(6,5297)(radiita(kk),kk=1,max_hrd_dim)
c           write(6,*)'radiitasim'
c           write(6,5297)(radiitasim(kk),kk=1,max_hrd_dim)
 5297	   format(8f10.5)
	   roll = roll + rcor
           ra = ra + hcor
           pitch = pitch + pcor
	   drift = drift + dcor
	   azm = azm + azmcor
	   az_t = azm + roll
           if(elev.lt.0.and.isweeptype.eq.0)then
 	    elev = elev - elcor1 + elcor2
           else
 	    elev = elev + elcor1 + elcor2
           endif
           gs = gs + vgscor
                elevsigntest=elev*elevbefore
                if(elevsigntest.lt.0.)then
                 write(6,*)'elev change from ',elevbefore, 
     1            'to ',elev
                 write(6,*)'azm = ',azm
                 if(isweeptype.eq.1)then
                  if(elev.lt.0.)then
                   beginazm = azm
                   write(6,*)'beginazm = ',beginazm
                  elseif(elev.gt.0.)then
                   endazm = azmbefore
                   write(6,*)'endazm = ',endazm
                  endif
                 elseif(isweeptype.eq.2)then
                  if(elev.gt.0.)then
                   beginazm = azm
                  else
                   endazm = azmbefore
                  endif
                 endif
c                 pause
                endif
           write(6,862)ih,im,is,azm,elev
         endif
         write(6,*)'just before enddo newsweep,az_t = ',newsweep,az_t
c         if(newsweep.eq.1)pause
	end do
C		<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Now get stats for scan
C
        write(6,*)'nrays,iaftyes,iforeyes = ',
     +   nrays,iaftyes,iforeyes
        write(6,*)'getting to solution'
c        pause
        rolldiff=roll_max-roll_min
        pitchdiff=pitch_max-pitch_min
        driftdiff=drift_max-drift_min
        write(6,*)'azm,beginazm,endazm = ',azm,beginazm,endazm
        if(nrays.gt.0)then
         aztestmean=aztest_mean/nrays
         azvariance=sqrt((aztest2_mean/nrays)-
     1              (aztest_mean*aztest_mean/nrays/nrays))
         write(6,*)'aztest_mean,aztest2_mean,nrays = ',
     1              aztest_mean,aztest2_mean,nrays
         write(6,*)'azmean,azrms = ',aztestmean,azvariance
c         pause
        endif
c        pause
        write(6,*)'checking a sweep and nrays = ',nrays
c        pause
	if(nrays .eq. 0)then
		write(6,*) ' no points sweep # ',ntasweep, ih,im,is
c           pause
        elseif((abs(rolldiff).gt.1..or.roll_max.gt.2..or.
     1        roll_min.lt.-2.).and.newsweep.eq.1)then
                write(6,*)'rolldiff,roll_min,roll_max = ',
     1           rolldiff,roll_min,roll_max
               nrays = 0
c               pause
        elseif(abs(pitchdiff).gt..5.and.newsweep.eq.1)then
              write(6,*)'pitchdiff = ',pitchdiff
              write(6,*)'pitch_min,pitch_max = ',pitch_min,pitch_max
               nrays = 0
c              pause
        elseif(abs(driftdiff).gt.1..and.newsweep.eq.1)then
              write(6,*)'driftdiff = ',driftdiff
               nrays = 0
c              pause
        elseif(abs(aztestmean).gt.5..or.azvariance.lt.35.)then
              write(6,*)'driftdiff = ',driftdiff
               nrays = 0
c              pause
c	elseif(newsweep.eq.1.and.iaftyes.eq.1.and.iforeyes.eq.1)then
	elseif(newsweep.eq.1)then
		write(6,*)' solving sweep # ', ntasweep,' ',ih,im,is
                write(6,*)' nsweeps = ',nsweeps
                write(6,*)'nrays = ',nrays
c        pause
C solve for Ac, B1, B2: 
d		write(outlu,*)'a,b,c,d,e,f,r,s,t:'
d		write(outlu,*)a,b,c,d,e,f,r,s,t
		call solv_3sys(a,b,c,d,e,f,r,s,t, Ac, B1, B2, ier)
C Stick in Lagrangian multipliers mu and mu1 (added 2 dec 92)
C
		npts = a
C note when i iterate on corrections, WC suggests using mu1 for E term
C but umtil then, use same mu for both...
		call solv_4sys(a,b,c,d,e,f,g,h,p, q, rp, sp, tp, zp, 
     +			Cc, D1, D2, Ec, mu, mu1, ier)
C Get standard deviations of fits:
		if( npts .gt. max_pts) npts = max_pts
		call std_devs(phi_n, vel_n, rng_n, npts, Ac, B1, B2, 
     +			Cc, D1, D2, Ec, stdvel, stdrange )
C For first crack at corrections use mean values of tilt, drift, Vh and altitude
C probaly invalid for fast if tilt changing radically
                   Vg_res_mean = Vg_res_mean / nrays
                   Vg_res2 = sqrt((vg_res2_sum - 
     +             vg_res_mean**2*nrays)/nrays)
      write(6,*)'vg_res min,mean,max,std = ',
     + vg_res_min,vg_res_mean,vg_res_max,vg_res2
		   tilt_mean = tilt_mean / nrays
		   Vh_mean = Vh_mean / nrays
		   alt_mean = alt_mean / nrays
		   dop_mean = dop_mean / npts
		   roll_mean = roll_mean / nrays
                   azm_mean = azm_mean /nrays
		   pitch_mean = pitch_mean / nrays
		   drift_mean = drift_mean / nrays
Cout		   tilt_cor(nsweeps) = tilt_cor(ntasweep) / npts
C  Use try tilt correction ala testud et al, assume drift and Vh constant
C in one scan, use mean tilt
		    tilt_fix = -Ac / ( Vh_mean * cosd(drift_mean) * 
     +			cosd(tilt_mean) )
		   tilt_cor(nsweeps) = tilt_fix * rad2deg
                   write(6,*)'tilt_cor = ',tilt_cor
C Write some stuff to nadir file (easier to read!), save for time series plot
C resid Vg = Ac + b1 * sin(phi) + b2 * cos(phi) which for phi = 0 
C (straight down) reduces to:
		resid_Vg(nsweeps) = Ac + B2
C Similarly resid Rg * cos(phi)*cos(phi) = 
C			(Cc + d1 * sin(phi) + d2 * cos(phi) + E cos(2phi)
C reduces to
		resid_Rg(nsweeps) = Cc + D2 + E
C Write out sweep num, time, and stats...
	time = ih * 3600 + im * 60 + is
	write(outlu)ntasweep,time, pitch_mean, pitch_max, pitch_min, 
     +		drift_mean, drift_max, drift_min, 
     +		roll_mean, roll_max, roll_min,
     +			Cc, D1, D2, Ec, Ac, B1, B2, nrays, npts
        write(lu3,213)ntasweep,ih,im,is,nrays,pitch_min,pitch_mean,
     +   pitch_max,drift_min,drift_mean,drift_max,
     +   roll_min,roll_mean,roll_max,azm_min,azm_mean,azm_max,
     +   tilt_min,tilt_mean,tilt_max
 213	format(1x,i4,1x,3i2.2,i6,2x,15f7.2)
	write(lu2,212)ntasweep, ih, im, is, pitch_mean, drift_mean, 
     +		roll_mean,
     +		   tilt_mean, Vh_mean, alt_mean, dop_mean, 
     +		   resid_Rg(nsweeps), resid_Vg(nsweeps),
     +		   tilt_cor(nsweeps)
212	format(1x,i3,1x,3i2.2,2x, 3(1x,f6.2),
     +	f6.2,1x,f5.1,2(1x,f6.1),3x, f7.1, 3x, f6.2,
     +	3x,f6.2)
222	format(1x,'swp',1x,'  Time  ',2x,' Pitch ',' Drift ','  Roll ',
     +	  ' el ave',' gs av',' RA ave','Dop ave',3x,'del Rng',3x,
     +    'del Vg',
     +	  3x,'tilt cor',3x,'tilt cor2')
C Get corrections as in in lee and testud code
		ave = gse ! ground speed
		avn = gsn
		call get_deltas(mu2, Ac, B1, B2, Cc, D1, D2,
     +		stdC, stdB2, stdbeta, stdw,
     +		drift_mean, tilt_mean, ave, avn, alt_mean, 
     +		del_phi, del_h, del_beta, del_w, del_vH, del_alpha)
C	del_phi - error in spin and roll angle 
C	del_h - height error
C	del_beta - pitch angle error
C 	del_w - aircraft vertical velocity error
C 	del_vH - aircraft velocity error
C 	del_alpha - drift error
C
C		call gen_corr(Ac, B1, B2, Cc, D1, D2, 
C     +	  	  tilt_mean, drift_mean, Vh_mean, alt_mean,
C     +	  	  d_Vh, d_pitch, d_rlaz, d_w, d_drift, d_tilt, d_alt)
C		d_pitch = d_pitch / deg2rad
C		d_drift = d_drift / deg2rad
C		d_tilt = d_tilt / deg2rad
C		d_rlaz = d_rlaz / deg2rad
C
                if(isweeptype.eq.1)del_Vh=-del_Vh
		d_pitch = del_beta
		d_drift = del_alpha
C		d_tilt = d_tilt / deg2rad
		d_rlaz = del_phi
		write(outlu) tilt_mean, Vh_mean, alt_mean,
     +			del_Vh, del_w, d_pitch, d_rlaz,  d_drift,
     +			del_h
		write(lu2,*) tilt_mean, tilt_cor(nsweeps),
     +			Vh_mean, alt_mean,
     +			del_Vh, del_w, d_pitch, d_rlaz,  d_drift,
     +			del_h
c       pause
	end if
C
200	format(1x,i3,1x,2(i2.2,':'),i2.2, 2x, 3(1x,f6.2), 2x, f7.1,
     +		' bad fit ')
c	if( plot_swps.and.iforeyes.eq.1.and.iaftyes.eq.1)then
	if( plot_swps)then
c	  write(6,*)' Plot it? '
c	  read(ireadlu,'(a)')yesno
          yesno = 'y'
	  if( (yesno.eq.'y') .or. (yesno .eq. 'Y') )then
	do ipl_type = 1, 2 ! --------------->>>
         write(6,*)'ipl_type = ',ipl_type
Cout	  ipl_type = 2
		width = 7.0
		depth = 6.0
		csiz = 0.1
		xl = 5.0 * csiz
		yb = 5.0 * csiz
		if( (plotter.eq.1) .or. (plotter.eq.51) )then 
			ires=400
			iwid=10 ! 0< means let plotter decide 
			call initl(plotter,ires,iwid,im,im,im,im) 
		else ! X windows display
			iwid = (width + 2.0 * xl) * 10
			iht =  (depth + 2.0 * yb) * 10
      write(6,*)'calling initl'
                        im1 = 1
                        im2 = -999
			call initl(plotter,ires,iwid,iht,im1,im2,im3) 
                        iorien = 1
			ifnt_size = nint(csiz * 72)
                        ipsplotter = -100
                        if(ipl_type.eq.2)then
			 call initl(ipsplotter,ires,iwid,iht,
     +				ipst_file,ifnt_size,iorien) 
                        endif
                        write(6,*)'im3 = ',im3
      write(6,*)'returned from initl'
		endif 
      write(6,*)'calling plot'
		call plot(0.0, 0.0, -3)
      write(6,*)'returned from plot'
      write(6,*)'calling splat'
                write(6,*)'npts = ',npts
		call splat(npts, phi_display, vel_display, 
     +            rng_n, ipl_type,
     +		  Ac, B1, B2, Cc, D1, D2, Ec , xl, yb, width,
     +		  depth, csiz)
      write(6,*)'returned from splat'
		csiz2 = csiz
		xl2 = xl + width + 5.0 * csiz
		yt = yb + depth - csiz
      write(6,*)'calling cap_titl'
		call cap_titl(flightid, ntasweep, ih, im, is, pitch, 
     +		  roll, drift, Cc, D1, D2, Ec, Ac, B1, B2, nrays, npts,
     +		  Vh_mean, alt_mean, tilt_mean, xl2, yt, csiz2)
      write(6,*)'returned from cap_titl'
      write(6,*)'calling plot'
c      pause
		call plot(0.0, 0.0, 998)
      write(6,*)'returned from plot 998'
COUT		pause
c      pause
		end do	! <<<---------------------------------------
	  end if
	end if

C get another sweep
c	if(ifbrk().ne.0) go to 900
	go to 100
900	ihe = ih	! true end time
	ime = im
	if( plot_time) then ! plot time series of del range and del Vg
	   do ipl_type = 1, 3
		width = 7.0
		depth = 6.0
		csiz = 0.1
		xl = 5.0 * csiz
		yb = 5.0 * csiz
		if( (plotter.eq.1) .or. (plotter.eq.51) )then 
			ires=400
			iwid=10 ! 0< means let plotter decide 
			call initl(plotter,ires,iwid,im,im,im,im) 
		else ! X windows display
			iwid = (width + 2.0 * xl) * 10
			iht =  (depth + 2.0 * yb) * 10
			ifnt_size = nint(csiz * 72)
			call initl(plotter,ires,iwid,iht,im,im,im) 
			iorien = 1 ! landscape
			call initl(-plotter,ires,iwid,iht,
     +				ipst_file,ifnt_size,iorien) 
		endif 
		call plot(0.0, 0.0, -3)
		call time_splat(ntasweep, iswp1, resid_Vg, resid_Rg, 
     +		  tilt_cor, ipl_type, xl, yb, width, 
     +		  depth, csiz)
		csiz2 = csiz
		xl2 = xl + width + 5.0 * csiz
		yt = yb + depth - csiz
		call cap_time(flightid, ntasweep, ihs, ims, ihe, ime,
     +		  ntasweep, xl2, yt, csiz2)
		call plot(0.0, 0.0, 998)
c		pause
	  end do
	end if
	write(6,*)' Adios.'
C 
C finish, close file { and write out average correction. }
	close(tape)
        totalsumw=0
        totalsumrres=0
        totalsumrres2=0
        totalsumvres=0
        totalsumvres2=0
        do i=1,14
         totalsumw=totalsumw+wvres(i)
         totalsumrres=totalsumrres+sumrres(i)
         totalsumrres2=totalsumrres2+sumrres2(i)
         totalsumvres=totalsumvres+sumvres(i)
         totalsumvres2=totalsumvres2+sumvres2(i)
         rresmean=sumrres(i)/wvres(i)
         rresrms=sqrt(sumrres2(i)/wvres(i))
         vresmean=sumvres(i)/wvres(i)
         vresrms=sqrt(sumvres2(i)/wvres(i))
         write(6,*)
     +'i,nvres(i),wvres(i),sumvres(i),sumvres2(i),vresmean,vresrms, = ',
     +    i,nvres(i),wvres(i),sumvres(i),sumvres2(i),vresmean,vresrms
         write(6,*)
     +'i,nvres(i),wvres(i),sumrres(i),sumrres2(i),rresmean,rresrms, = ',
     +    i,nvres(i),wvres(i),sumrres(i),sumrres2(i),rresmean,rresrms
        enddo
        rresmeantotal=totalsumrres/totalsumw
        rresrmstotal=sqrt(totalsumrres2/totalsumw)
        vresmeantotal=totalsumvres/totalsumw
        vresrmstotal=sqrt(totalsumvres2/totalsumw)
        write(6,*)'total del_Rg mean,rms = ',rresmeantotal,rresrmstotal
        write(6,*)'total Vg_res mean,rms = ',vresmeantotal,vresrmstotal
	close(outlu)
        open(outlu,file='rgvgres')
        write(outlu,*)rresmeantotal,rresrmstotal
        write(outlu,*)vresmeantotal,vresrmstotal
        close(outlu)
c        pause
1000	end
C ----------------------------------
	subroutine find_ground(deg2rad, beam_wid, 
     +		rs_th, rs_m, dBz_max, ibeg, Ng2,
     +  elevsim,pitchsim,azmsim,rollsim,rasim,radiitasim)
      include "hrd_radar_common_blocks.f"
        real radiitasim(max_hrd_dim)
C Find the surface, as in Testud's memo.
	real lambda
C
        elev2 = elevsim
	theta = elev * deg2rad ! tilt relative to plane perp to radar axis
        theta2 = elev2 * deg2rad
        pitch2 = pitchsim
	beta = pitch * deg2rad
        beta2 = pitch2 *deg2rad
        azm2 = azmsim
C In Testud's form, 0 is down, -90 port, 90 starboard:
	phi = (azm + roll - 180) * deg2rad 
        phi2 = (azm2 + rollsim - 180) * deg2rad
	epsilon = beam_wid * deg2rad
C Now get elevation of beam rel to horizontal plane through radar
	sn_lambda = sin(theta) * sin(beta) - 
     *			cos(theta) * cos(beta) * cos(phi)
	lambda = asin(sn_lambda)
	sn_lambda2 = sin(theta2) * sin(beta2) - 
     *			cos(theta2) * cos(beta2) * cos(phi2)
	lambda2 = asin(sn_lambda2)
C Find theoretical range of surface. - sign because lambda neg
	rs_th = -ra / sn_lambda ! ra in m, radiita in km
        rs_th_2 = -rasim / sn_lambda2
C Find # of gates intersecting surface at theoretical range
C This would be formula if dR was constant:
C	Ng = rs_th * epsilon / (dR * tan(lambda) )
C But we may have varying beamwidths, so
Cout	slant_depth = -rs_th * epsilon / tan(lambda) ! slight approximation
Cout	rs_th_in = ( rs_th - slant_depth * 0.5 ) * 0.001
Cout	rs_th_out = ( rs_th + slant_depth * 0.5 ) * 0.001
C mod dec 8 92:
	rs_th_in = -ra / sin(lambda - epsilon * 0.5) * 0.001
	rs_th_out = -ra / sin(lambda + epsilon * 0.5) * 0.001
	rs_km = rs_th * 0.001
	in = -1
	do i = 1, max_hrd_dim
	    if( radiitasim(i) .gt. 0.0 )then
		if(radiitasim(i) .lt. rs_th_in) in = i
		if(radiitasim(i) .le. rs_th_out) iout = i
		if(radiitasim(i) .le. rs_km) Nr = i
	    end if
	end do
        write(6,*)'rs_th_in,rs_km,rs_th_out,in,iout,Nr = ',
     +   rs_th_in,rs_km,rs_th_out,in,iout,Nr
	if(in .eq. -1)then
		write(6,*)' find_ground failure!'
		write(6,*)' ra:',ra
		write(6,*)'azm, phi: ', azm, phi
		write(6,*)'pitch, drift, roll: ',pitch, drift, roll
		write(6,*)'el, sin(lambda), lambda:',elev, 
     +			sn_lambda, lambda
		write(6,*)'rs_th_in, rs_th_out, rs_km:'
		write(6,*)rs_th_in, rs_th_out, rs_km
		write(6,*)' find_gs in, iout, Nr: ',in, iout, Nr
c		pause ' pausing for this mystery '
		ibeg = -1
		return
	end if
	Ng = iout - in + 1
	Ng2 =  0.5 * Ng
	if (Ng2 .eq. 0) Ng2 = 1
C changed radius of check to 30 bins = 2.25 km, because of huge
C range delays in Andrew 8 dec 92
C Then search the gates within +- 30 of gate at theoretical
C range to find the swath Ng/2 wide with greatest Total Ze.
C Return bounding bins.
	dBz_max = -1.0
	ibeg = -1
	ist = max(6, Nr - 30)
	ien = min(max_hrd_dim-Ng2, Nr + 30 -Ng2)
d	write(6,*)'find_gd ist, ien: ',ist, ien
	do i = ist, ien
	   dBzsum = 0.0
	   do j = i, i + Ng2
		dBzsum = dBzsum + dbzbuffer(j)
	   end do
	   if( dBzsum .gt. dBz_max)then
		dBz_max = dBzsum
		ibeg = i
	   end if
	end do
        ibegsave = ibeg
        ibeg = -1
        dbzmaxx=10.
        j1 = ist
        j2 = ien
        if (j1.lt.1)j1=1
        if (j2.gt.max_hrd_dim)j2=max_hrd_dim
c        write(6,*)'j1,j2,in,iout,Nr = ',j1,j2,in,iout,Nr
        imaxx=Nr
        do j=j1,j2
         if(dbzbuffer(j).gt.dbzmaxx)then
          imaxx=j
          dbzmaxx=dbzbuffer(j)
          ibeg=1
         endif
c         write(6,*)'ibeg,imaxx,j,dbzbuffer,widthbuffer,dbzmaxx = ',
c     +     ibeg,imaxx,j,dbzbuffer(j),widthbuffer(j),dbzmaxx
        enddo
        Ng2=0
        if(ibeg.eq.1)then
         ibeg=imaxx
        endif
c        ibeg = ibegsave
        iradius=ibeg
c        write(6,*)'Nr,j1,j2,ibeg = ',Nr,j1,j2,ibeg
c	iradius = ibeg + Ng2 * 0.5
	if( iradius .le.0) iradius = 1
	rs_m = radiitasim( iradius ) * 1000.0
c        write(6,*)'returning and imaxx,ibeg = ',imaxx,ibeg
	return
	end
C ----------------------------------
	subroutine find_ground_old(deg2rad, beam_wid, 
     +		rs_th, rs_m, dBz_max, ibeg, Ng2,
     +   elevsim,pitchsim,azmsim,rollsim,rasim,radiitasim)
      include "hrd_radar_common_blocks.f"
C Find the surface, as in Testud's memo.
	real lambda
        real radiitasim(max_hrd_dim)
C
	theta = elev * deg2rad ! tilt relative to plane perp to radar axis
	beta = pitch * deg2rad
C In Testud's form, 0 is down, -90 port, 90 starboard:
	phi = (azm + roll - 180) * deg2rad 
	epsilon = beam_wid * deg2rad
C Now get elevation of beam rel to horizontal plane through radar
	sn_lambda = sin(theta) * sin(beta) - 
     *			cos(theta) * cos(beta) * cos(phi)
	lambda = asin(sn_lambda)
C Find theoretical range of surface. - sign because lambda neg
	rs_th = -ra / sn_lambda ! ra in m, radiita in km
C Find # of gates intersecting surface at theoretical range
C This would be formula if dR was constant:
C	Ng = rs_th * epsilon / (dR * tan(lambda) )
C But we may have varying beamwidths, so
Cout	slant_depth = -rs_th * epsilon / tan(lambda) ! slight approximation
Cout	rs_th_in = ( rs_th - slant_depth * 0.5 ) * 0.001
Cout	rs_th_out = ( rs_th + slant_depth * 0.5 ) * 0.001
C mod dec 8 92:
	rs_th_in = -ra / sin(lambda - epsilon * 0.5) * 0.001
	rs_th_out = -ra / sin(lambda + epsilon * 0.5) * 0.001
	rs_km = rs_th * 0.001
	in = -1
	do i = 1, max_hrd_dim
	    if( radiitasim(i) .gt. 0.0 )then
		if(radiitasim(i) .lt. rs_th_in) in = i
		if(radiitasim(i) .le. rs_th_out) iout = i
		if(radiitasim(i) .le. rs_km) Nr = i
	    end if
	end do
	if(in .eq. -1)then
		write(6,*)' find_ground failure!'
		write(6,*)' ra:',ra
		write(6,*)'azm, phi: ', azm, phi
		write(6,*)'pitch, drift, roll: ',pitch, drift, roll
		write(6,*)'el, sin(lambda), lambda:',elev, 
     +			sn_lambda, lambda
		write(6,*)'rs_th_in, rs_th_out, rs_km:'
		write(6,*)rs_th_in, rs_th_out, rs_km
		write(6,*)' find_gs in, iout, Nr: ',in, iout, Nr
c		pause ' pausing for this mystery '
		ibeg = -1
		return
	end if
	Ng = iout - in + 1
	Ng2 =  0.5 * Ng
	if (Ng2 .eq. 0) Ng2 = 1
C changed radius of check to 30 bins = 2.25 km, because of huge
C range delays in Andrew 8 dec 92
C Then search the gates within +- 30 of gate at theoretical
C range to find the swath Ng/2 wide with greatest Total Ze.
C Return bounding bins.
	dBz_max = -1.0
	ibeg = -1
	ist = max(1, Nr - 30)
	ien = min(max_hrd_dim-Ng2, Nr + 30 -Ng2)
d	write(6,*)'find_gd ist, ien: ',ist, ien
	do i = ist, ien
	   dBzsum = 0.0
	   do j = i, i + Ng2
		dBzsum = dBzsum + dbzbuffer(j)
	   end do
	   if( dBzsum .gt. dBz_max)then
		dBz_max = dBzsum
		ibeg = i
	   end if
	end do
c1        ibegsave = ibeg
c1        ibeg = -1
c1        dbzmaxx=-32.
c1        j1 = ist
c1        j2 = ien
c1        if (j1.lt.1)j1=1
c1        if (j2.gt.max_hrd_dim)j2=max_hrd_dim
c1c        write(6,*)'j1,j2,in,iout,Nr = ',j1,j2,in,iout,Nr
c1        imaxx=Nr
c1        do j=j1,j2
c1         if(dbzbuffer(j).gt.dbzmaxx)then
c1          imaxx=j
c1          dbzmaxx=dbzbuffer(j)
c1          ibeg=1
c1         endif
c1c         write(6,*)'j,dbzbuffer,dbzmaxx = ',j,dbzbuffer(j),dbzmaxx
c1        enddo
c1c        Ng2=0
c1        if(ibeg.eq.1)then
c1         ibeg=imaxx
c1        endif
c1        ibeg = ibegsave
        iradius=ibeg
c        write(6,*)'Nr,j1,j2,ibeg = ',Nr,j1,j2,ibeg
c	iradius = ibeg + Ng2 * 0.5
	if( iradius .le.0) iradius = 1
	rs_m = radiitasim( iradius ) * 1000.0
	return
	end
C --------------------------
	subroutine acc_sums(deg2rad, azm, Vg_res, del_Rg,
     +		a,b,c,d,e,f,g,h,p,q,r,s,t, rp, sp, tp, zp,Ng2,icount)
C
        icount = icount + 1
        weight=1./(1+Ng2*2)
	phi = (azm - 180) * deg2rad
	cos_p = cos(phi)
	cos_2p = cos(2.0*phi)	! added 2 dec 1992
	cos_sq = cos_p * cos_p
	sin_p = sin(phi)
	a = a + weight
	b = b + weight*sin_p**2
	c = c + weight*cos_p**2
	d = d + weight*sin_p
	e = e + weight*cos_p
	f = f + weight*cos_p * sin_p
C changed the next 3 and added q on 2 dec 1992
	g = g + weight*cos_2p
	h = h + weight*cos_2p * sin_p
	p = p + weight*cos_2p * cos_p
	q = q + weight*cos_2p**2
C
	r = r + weight*Vg_res
	s = s + weight*Vg_res * sin_p
	t = t + weight*Vg_res * cos_p
C
	rp = rp + weight*del_Rg * cos_sq
	sp = sp + weight*del_Rg * cos_sq * sin_p
	tp = tp + weight*del_Rg * cos_sq * cos_p
	zp = zp + weight*del_Rg * cos_sq * cos_2p	! changed on dec 2
C
	return
	end
C ----------------------------
	subroutine zero_sums(a,b,c,d,e,f,g,h,p,q,
     +		r,s,t, rp, sp, tp, zp, icount)
        icount =0
	a = 0.0
	b = 0.0
	c = 0.0
	d = 0.0
	e = 0.0
	f = 0.0
	g = 0.0
	h = 0.0
	p = 0.0
	q = 0.0
C
	r = 0.0
	s = 0.0
	t = 0.0
C
	rp = 0.0
	sp = 0.0
	tp = 0.0
	zp = 0.0
	return
	end
C ------------------------
	subroutine solv_3sys(a,b,c,d,e,f,r,s,t, Ac, B1, B2, ier)
	real a,b,c,d,e,f,r,s,t, Ac, B1, B2
	integer ier
	real am(3,3), vec(3)
	integer indx(3)
	am(1,1) = a
	am(1,2) = d
	am(1,3) = e
	am(2,2) = b
	am(2,3) = f
	am(3,3) = c
	am(2,1) = d
	am(3,1) = e
	am(3,2) = f
C solve the system
C 	(a   d   e)   (Ac)     (r)
C	(d   b   f)   (B1)  =  (s)
C	(e   f   c)   (B2)     (t)
C
c	det = a*b*c + 2.0 * d*e*f - a*f**2 - b*e**2 - c*d**2
C check det
c	if( abs(det) .lt. 1.0e-5)then
c		ier = -1
c		Ac = -1
c		B1 = -1
c		B2 = -1
c		return
c	end if
C
c	det = 1.0/ det
C
c	Ac = det * (r * (b*c -f*2) + s * (e*f - c*d) +
c     *		t * (d*f - e*b) )
c	B1 = det * (r * (e*f - c*d) + s * (a*c - e**2)  +
c     *		t * (e*d - a*f) )
c	B2 = det * (r * (d*f - e*b) + s * (e*d -a*f) +
c     *		t * (a*b - d**2) )
	call ludcmp(am, 3, 3, indx, d, ier)
	if( ier .eq. 0)then
		vec(1) = r
		vec(2) = s
		vec(3) = t
		call lubksb( am, 3, 3, indx, vec)
		Ac = vec(1)
		B1 = vec(2)
		B2 = vec(3)
	end if
	return
	end
C ------------------------------
	subroutine solv_4sys(a,b,c,d,e,f,g,h,p,q,r,s,t,z, 
     +		Cc, D1, D2, Ec, mu, mu1, ier)
C solve the system
C 	(a   d   e  g)   (Cc)     (r)
C	(d   b   f  h)   (D1)  =  (s)
C	(e   f   c  p)   (D2)     (t)
C	(g   h   p  q)   (Ec)     (z)
C Added Lagrangian multipliers as in appendix 2 of Testud et al
C Note that initial run throught of data should be called with mu = mu1
C as in paper, but after correcting a different, smaller mu1 would be used
C to lessen the weight on E term... a trick of Wen Chaus's that may not 
C be mathematically consistent, but seems to work in practice.
	real a,b,c,d,e,f,g,h,p,q,r,s,t,z, Cc, D1, D2, Ec
	real mu, mu1
	real am(4,4), xvec(4)	! , ainv(4,4), workspace(40)
	integer indx(4)
	ier = 0
C Load up matrix
	npts = a
	am(1,1) = a * (1.0 + mu)
c	am(1,1) = a 
	am(1,2) = d
	am(1,3) = e
	am(1,4) = g
	am(2,2) = b 
	am(2,3) = f
	am(2,4) = h
	am(3,3) = c + npts * mu
	am(3,4) = p
	am(4,4) = q + npts * mu1
C
	am(2,1) = d
	am(3,1) = e
	am(3,2) = f
	am(4,1) = g
	am(4,2) = h
	am(4,3) = p
C get  inverse:
c	idgt = 0 ! means something about accuracy of inverse ???
c	call linv2f(am,4,4,ainv,idgt,workspace,ier)
c	if(ier .eq. 129)then
c		ier = -1 ! singular
c		return
c	else if(ier .eq. 131)then
c		ier = -2 ! ill conditioned
c		return
c	else if(ier .eq. 34)then
c		ier = -3 ! failed acc (??)
c	end if
C if inverse ok get coefficients
c	do i = 1, 4
c	  xvec(i) = r * ainv(i,1) + s * ainv(i,2) + t * ainv(i,3) +
c    +		z * ainv(i,4)
c	end do
C
Cd	write(6,*)' r, s, t, z: ', r , s, t, z
Cd	write(6,*)' 4th row of inverse: ',(ainv(4,i),i=1,4)
Cd	pause 'pausing'
	call ludcmp(am, 4, 4, indx, d, ier)
	if( ier .eq. 0)then
		xvec(1) = r 
		xvec(2) = s 
		xvec(3) = t
		xvec(4) = z
		call lubksb( am, 4, 4, indx, xvec)
		Cc = xvec(1)
		D1 = xvec(2)
		D2 = xvec(3)
		Ec = xvec(4)
	end if
	return
	end
C -----------------------
	subroutine get_residual( ibin, xnyq, Vr_res, Vr,
     +  elevsim,driftsim,pitchsim,azmsim,rollsim)
      include "hrd_radar_common_blocks.f"
C subtract air speed projected on Doppler ray from total Vr;
C if target is ground residual is motion of ground!
C
c      COMMON /RAYHEADER / nbytesdata,nlfsweep,ntasweep,numrecord,
c     +                    irecflag,idradar,nbytesray,icode,idsp,mdata,
c     +                    iyear,month,iday,iraycode,time,ih,im,
c     +                    is,is100,rlat,rlon,ra,gse,gsn,gs,vgs,
c     +                    ucom,vcom,wd,ws,vws,ircu,
c     +                    elev,azm,pitch,roll,drift,heading,
c     +                    dbzbuffer(max_hrd_dim),velbuffer(max_hrd_dim),
c     +                    widthbuffer(max_hrd_dim)
C
C MAKE SURE sign of drift is correct !!! (only matters for sin(drift) )
	phi = azm + roll -180.
        phisim = azmsim + rollsim - 180.
c       write(6,*)'1,phi,drift,pitch,elev = ',phi,drift,pitch,elev
c       write(6,*)'2,phisim,driftsim,pitchsim,elevsim = ',
c     + phisim,driftsim,pitchsim,elevsim
C angle of radar beam relative to radar velocity:
	cos_psi = cosd(pitch) * cosd(drift) * sind(elev) +
     +	   sind(pitch) * cosd(drift) * cosd(elev) * cosd(phi) -
     +	   sind(drift) * cosd(elev) * sind(phi)
C angle of beam with horiz plane at radar
	sin_lambda = sind(elev) * sind(pitch) - 
     *			cosd(elev) * cosd(pitch) * cosd(phi)
C component of aircraft motion along Doppler ray
	sin_lambda_test = sind(elevsim) * sind(pitchsim) - 
     *			cosd(elevsim) * cosd(pitchsim) * cosd(phisim)
	cos_psi_test = cosd(pitchsim) * cosd(driftsim) * sind(elevsim) +
     +	   sind(pitchsim) * cosd(driftsim) * cosd(elevsim) 
     +  * cosd(phisim) -
     +	sind(driftsim) * cosd(elevsim) * sind(phisim)
	Vrg = - gs * cos_psi - vgs * sin_lambda
	Vrg_test = - gs * cos_psi_test - vgs * sin_lambda_test
C
	n_nyq = Vrg / ( 2.0 * xnyq )	! # of nyquist intervals
	rem = Vrg - n_nyq * xnyq * 2.0
	if( rem .gt. xnyq ) then
	   n_nyq = n_nyq + 1
	   rem = Vrg - n_nyq * xnyq * 2.0
	else if( rem .lt. -xnyq ) then
	   n_nyq = n_nyq - 1
	   rem = Vrg - n_nyq * xnyq * 2.0
	end if
	del = velbuffer(ibin)-rem
c      write(44,*)'Vrg,velbuffer,rem,gs,elev,cos_psi,sin_lambda,del = ',
c     1            Vrg,velbuffer(ibin),rem,gs,elev,cos_psi,sin_lambda,
c     1            del
	if( del .lt. -xnyq )then
		del = 2.0 * xnyq + del
	else if( del .gt. xnyq )then
		del = -(2.0 * xnyq - del)
	end if
C Residual Doppler vel of ground is negative of ground radial velocity.
c minus sign removed to reflect the paper
	Vr_res = del 
	Vr = Vrg_test 
	return	
	end
C ---------------------------------------
	subroutine get_tilt_cor( xnyq, Vr, tilt, max_iter,
     +		tilt_cor)
      include "hrd_radar_common_blocks.f"
C using doppler velocity at ground, find tail correction,
C assuming perfect pitch, drift and roll. note i use passed tilt
C instead of elev, in case i have already fiddled with it.
C
c      COMMON /RAYHEADER / nbytesdata,nlfsweep,ntasweep,numrecord,
c     +                    irecflag,idradar,nbytesray,icode,idsp,mdata,
c     +                    iyear,month,iday,iraycode,time,ih,im,
c     +                    is,is100,rlat,rlon,ra,gse,gsn,gs,vgs,
c     +                    ucom,vcom,wd,ws,vws,ircu,
c     +                    elev,azm,pitch,roll,drift,heading,
c     +                    dbzbuffer(max_hrd_dim),velbuffer(max_hrd_dim),
c     +                    widthbuffer(max_hrd_dim)
C
C MAKE SURE sign of drift is correct !!! (only matters for sin(drift) )
	phi = azm + roll - 180.  ! in testud coordinates
	a1 = sind(pitch) * cosd(drift) * cosd(phi) -
     +	   sind(drift) * sind(phi)
	b1  = cosd(pitch) * cosd(drift)
C	cos_psi = a1 * cosd(elev) + b1 * sind(elev)
C angle of beam with horiz plane at radar
	c1 = -cosd(pitch) * cosd(phi)
	d1 = sind(pitch)
C	sin_lambda = c1 * cosd(elev) + d1 * sind(elev) 
C
	e = -( b1 * gs + d1 * vgs )
	f = -( a1 * gs + c1 * vgs )
C component of aircraft motion along Doppler ray
C	V = - gs * cos_psi - vgs * sin_lambda
	V = e * sind(elev) + f * cosd(elev)
	n_nyq = V / ( 2.0 * xnyq )	! # of nyquist intervals
	rem = V - n_nyq * xnyq * 2.0
	if( rem .gt. xnyq ) then
	   n_nyq = n_nyq + 1
	   rem = V - n_nyq * xnyq * 2.0
	else if( rem .lt. -xnyq ) then
	   n_nyq = n_nyq  - 1
	   rem = V - n_nyq * xnyq * 2.0
	end if
C Finally, the unfolded Doppler velocity:
	vdop = Vr + 2.0 * n_nyq * xnyq
C Now we want to find the tilt that would give ac vel = unfolded vdop
C by finding zero of f(el) = vdop - e sin(el) - f cos(el)
C by Newtons method. For the first guess, use the passed tilt angle
	e1 = elev * acos(-1.0) / 180.0
	del = abs(vdop - e*sin(e1) - f* cos(e1) )
	iter = 0
	do while ( del .gt. 0.01 ) ! to within 0.01 m/s
		iter = iter + 1
		if( iter .gt. max_iter) then
			write(6,*)' max iter ', max_iter
			go to 111
		end if
		e0 = e1
		e1 = e0 - (vdop - e*sin(e0) - f* cos(e0) ) /
     +			(-e * cos(e0) + f * sin(e0) )
		del = abs(vdop - e*sin(e1) - f* cos(e1) )
	end do
111	e1 = e1 * 180 / acos(-1.0)
C Tilt cor is difference between old tilt and new:
	tilt_cor = elev - e1
	return	
	end
C ------------------------------------------------------------
	subroutine gen_corr(Ac, B1, B2, Cc, D1, D2, 
     +	  tilt, drift, Vh, alt,
     +	  d_Vh, d_pitch, d_rlaz, d_w, d_drift, d_tilt, d_alt)
C generate corrections as in Testud's memo:
	cos_tilt = cosd(tilt)
	sin_tilt = sind(tilt)
	tan_tilt = sin_tilt / cos_tilt
	cos_dr = cosd(drift)
	sin_dr = sind(drift) 
C The easy ones:
	d_pitch = - Cc * cos_tilt / (alt * tan_tilt)
	d_rlaz = -D1 * cos_tilt / alt
	d_w = B2 / cos_tilt - Vh * ( sin_dr * d_rlaz -
     *			cos_dr * d_pitch)
C To get the remaining eroors we have to make some assumption
C for a first crack we will assume d_Vh = 0.0
	d_Vh = 0.0
	cnc = cos_dr * cos_tilt
	sns = sin_dr * sin_tilt
	div = cnc*cnc - sns*sns ! drift = tilt = 45deg should NEVER happen
	sun = -(Ac + cos_dr * sin_tilt * d_Vh ) / Vh
	chandra = -(B1 - sin_dr * cos_tilt * d_Vh) / Vh
	d_drift = (sns * sun - cnc * chandra) / div
	d_tilt = (cnc * sun - chandra * sns) / div
C Finally, estimate error in altitude:
	d_alt = D2 * cos_tilt + alt * tan_tilt * d_tilt
C
	return
	end
C -------------------------------------
	subroutine get_deltas(mu2, a, b1, b2, c, d1, d2,
     +		stdc, stdb2, stdbeta, stdw,
     +		drift, tilt_mean, ave, avn, height, 
     +		del_phi, del_h, del_beta, del_w, del_vH, del_alpha)
C code to generate delta of various parameters, based
C on least squares fit of range to ground and residual doppler
C velocity of ground from several rays in a radar sweep, lifted from 
C NCAR code plotscatter by wc lee, j testud, s smith, anf j hackney.
C I changed some variable names , and 
C re arranged terms, so I could understand what is going on...
C 	Corrected on 1 March 1995, to agree with latest version of 
C Testud et al. Equation numbers in comments correspond to 31 Jan 95 
C version of paper. There are sign differences with plotscatterN.f
C Input variables:
C 	mu2 - Lagrangian multiplier
C	a, b1, b2, c, d1, d2 - from least squares estimate
C	stdc, stdb2, stdbeta, stdw - standard deviations
C 	 of C, B2, pitch, and vertical velocity
C Those values were assumed to be ~10m, 0.1 m/s, 0.02deg,
C and 0.1 m/s in Testud et al. They could be calculated also...
C	drift, tilt_mean (eltail) - tilt in hrd terminology = tail antenna el
C	ave, avn = u and v components of aircraft velocity
C	height = measured aircraft altitude
C Output variables:
C Note I output ERRORS, which would be subtracted to get correct angles.
C	del_phi - error in spin and roll angle 
C	del_h - height error
C	del_beta - pitch angle error
C 	del_w - vertical velocity error
C 	del_vH - aircraft velocity error
C 	del_alpha - drift error
	real mu2, a, b1, b2, c, d1, d2,	stdc, stdb2, stdbeta, 
     +		stdw, drift, tilt_mean, ave, avn, height, del_phi, 
     +		del_h, del_beta, del_w, del_vH, del_alpha
C
	rad2deg = 180 / acos(-1.0)
	deg2rad = 1.0 / rad2deg
C terms used several times:
	eltail=tilt_mean * deg2rad
	drift_rad  = drift * deg2rad
	ac_vel = sqrt( ave**2 + avn**2 )
	elt_fac = tan(eltail) / cos(eltail)
C del of azm+roll   	eqn 36
	del_phi = (d1 * cos(eltail) / height) * rad2deg
C del of height		eqn 37
	del_h = d2 * cos(eltail)
C del of horizontal ground speed	eqn 39
	del_vh = -cos(drift_rad) * a / sin(eltail) +
     +		sin(drift_rad) * b1 / cos(eltail)
        write(6,*)'a,b1,del_vh = ',a,b1,del_vh
C del of drift		eqn 38
        write(6,*)'tilt_mean = ',tilt_mean
	del_alpha = b1 / ac_vel / cos(eltail) * rad2deg
C Factor D in variational solution, from Testud et al eqn 48
	dt = ( (height* elt_fac/stdc )**2 + mu2 / stdbeta**2) *
     X		cos(eltail)**2 / (stdb2**2) +
     X		( (ac_vel**2 * cos(drift_rad)**2 * cos(eltail)**2) /
     X		stdb2**2  + (height*elt_fac)**2 /
     X		stdc**2 + mu2 / stdbeta**2 ) *mu2 / stdw**2
C del of pitch		eqn 46
        del_beta1 = height*sin(eltail)*c/(dt*stdb2**2*stdc**2)
        del_beta2 = -mu2/stdw**2*ac_vel*cos(drift_rad)*cos(eltail)*
     x              b2/stdb2**2/dt
        del_beta3 = height*elt_fac*c/stdc**2/dt
        del_beta1 = del_beta1*rad2deg
        del_beta2 = del_beta2*rad2deg
        del_beta3 = del_beta3*rad2deg
        del_betatest = del_beta1+del_beta2+del_beta3
 	del_beta = ( (c * height * sin(eltail) ) /
     X		( (stdb2 * stdc) **2 ) -
     X		mu2/stdw**2*( ac_vel) *
     X		cos(drift_rad) * cos(eltail) * b2 / stdb2**2 - 
     X		height  * elt_fac * c / (stdc**2) ) / dt
 	del_beta = del_beta * rad2deg
        del_beta_simple = c * cos(eltail) / height / elt_fac
        del_beta_simple = del_beta_simple * rad2deg
        write(6,*)'db1,db2,db3,dbtest,db,db_simple,da = ',
     x  del_beta1,del_beta2,del_beta3,del_betatest,del_beta,
     x  del_beta_simple,del_alpha
C del of aircraft vertical velocity	eqn 47
	del_w = (-ac_vel * cos(drift_rad) * height *
     X		sin(eltail) * c / (stdc*stdb2)**2 -
     X		(height * elt_fac)**2 * b2 * cos(eltail) / 
     X		(stdc*stdb2)**2 -
     X		mu2 * cos(eltail) * b2/ (stdbeta*stdb2)**2 ) / dt
	return
	end
C --------------------------------------
	subroutine std_devs(phi_n, vel_n, rng_n, npts, A, B1, B2, 
     +			C, D1, D2, E, stdvel, stdrange )
C compute standard deviation of fits to residual dopler vel and
C radar range to ground. Adapted from lee and testud
	real phi_n(npts), vel_n(npts), rng_n(npts), A, B1, B2,
     +		C, D1, D2, E, stdvel, stdrange
C
	var_v = 0.0
	var_r = 0.0
	do i = 1, npts
	   v_fit = A + B1 * sin( phi_n(i) ) + B2 * cos(phi_n(i) )
	   r_fit = C + D1 * sin( phi_n(i) ) + D2 * cos(phi_n(i) ) +
     +		   E * cos(2.0 * phi_n(i) )
	   r_fit = r_fit / cos(phi_n(i))**2
	   var_v = var_v + ( vel_n(i) - v_fit)**2 
	   var_r = var_r + ( rng_n(i) - r_fit)**2 
	end do
	stdvel = sqrt( var_v / npts )
	stdrange = sqrt( var_r / npts )
	return
	end
C --------------------
	subroutine splat(npts, phi_n, vel_n, rng_n, plot_type,
     +		A, B1, B2, C, D1, D2, E , xl, yb, width, depth,csiz)
C plot corrected versus raw data values
	real phi_n(npts), vel_n(npts), rng_n(npts)
	integer plot_type
	real A, B1, B2, C, D1, D2, E
	character cstr*10
	integer*2 string(5)
C
        write(6,*)'entered splat'
        write(6,*)'phi_n = ',(phi_n(i),i=1,npts)
        write(6,*)'vel_n = ',(vel_n(i),i=1,npts)
	xr = xl + width
	yt = yb + depth
	xc = xl + width * 0.5
	yc = yb + depth * 0.5
c        xc = xl
c        yc = yl
	deg2rad = acos(-1.0)/180.0
	xscale = width / (360.0 * deg2rad)
        write(6,*)'one'
	call plot(xc,yb,3)
        write(6,*)'two'
        write(6,*)'xc,yb,csiz = ',xc,yb,csiz
	call plot(xc,yb+2.0*csiz,2)
        write(6,*)'three'
	cstr(1:6) = 'Nadir ' 
	read(cstr(1:6),'(3a2)')(string(i), i = 1,3)
	x1 = xc - 2.5 * csiz
        write(6,*)'four'
	call symbl(x1,yb - 3.0 * csiz, csiz, string,0.0,6)
        write(6,*)'five'
	cstr(1:4) = 'Phi ' 
	read(cstr(1:4),'(2a2)')(string(i), i = 1,2)
	call symbl(xl,yb - 3.0 * csiz, csiz, string,0.0,4)
        write(6,*)'six'
        write(6,*)'plotting x scale'
	do i = 0, 170, 10
		x1 = xc + i * deg2rad * xscale
		call plot(x1,yb,3)
		call plot(x1, yb + csiz, 2)
		x2 = xc - i * deg2rad * xscale
		call plot(x2,yb,3)
		call plot(x2, yb + csiz, 2)
		if( mod(i,10).eq.0)then
		  cstr = ' '
		  write(cstr(1:3),'(i3)')i
		  read(cstr(1:4),'(2a2)')string(1), string(2)
		  x1 = x1 - 1.5 * csiz
		  call symbl(x1,yb - 1.5 * csiz, csiz, string,0.0,3)
		  write(cstr(1:3),'(i3)')-i
		  read(cstr(1:4),'(2a2)')string(1), string(2)
		  x2 = x2 - 1.5 * csiz
		  call symbl(x2,yb - 1.5 * csiz, csiz, string,0.0,3)
		end if
	end do
        write(6,*)'plotting box'
	call plot(xl, yb, 3)
	call plot(xl, yt, 2)
	call plot(xr, yt, 2)
	call plot(xr, yb, 2)
	call plot(xl, yb, 2)
	if(plot_type .eq. 1) then ! range
	   cstr = 'del range '
	   read(cstr(1:10), '(5a2)' )(string(i), i = 1, 5)
           write(6,*)'writing del range'
	   call symbl(xl,yt + 0.5 * csiz, csiz, string, 0.0, 10)
	   yscale = (depth*0.5) / 4000.0
           write(6,*)'writing vertical scale for del range'
	   do i = 0, 4000, 500
		y = yc + i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		cstr = ' '
		write(cstr(1:4),'(i4)')i
		read(cstr(1:4),'(2a2)')string(1), string(2)
		y = y - 0.5 * csiz
		call symbl(xl - 4.5 * csiz, y, csiz, string,0.0,4)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,4)
		y = yc - i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		write(cstr(1:5),'(i5)')-i
		read(cstr(1:5),'(3a2)')string(1), string(2), string(3)
		y = y - 0.5 * csiz
		call symbl(xl - 5.5 * csiz, y, csiz, string,0.0,5)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,5)
	   end do
	   phi = -180 * deg2rad
	   x = xc + phi * xscale
	   r_fit = C + D1 * sin( phi ) + D2 * cos(phi ) +
     +		   E * cos(2.0 * phi )
	   y = yc + r_fit * yscale
           write(6,*)'plotting del range fit'
	   call plot(x, y, 3)
	   do i = -179, 180
		phi = i * deg2rad
		x = xc + phi * xscale
	   	r_fit = C + D1 * sin( phi ) + D2 * cos(phi ) +
     +		   E * cos(2.0 * phi )
		y = yc + r_fit * yscale
		call plot(x, y, 2)
	   end do
           write(6,*)'plotting del range scatter'
	   do i = 1, npts
		x = xc + phi_n(i) * xscale
		y = yc + rng_n(i) * yscale
		call plot(x, y-csiz, 3)
		call plot(x, y+csiz, 2)
		call plot(x-csiz, y, 3)
		call plot(x+csiz, y, 2)
	   end do
	else if(plot_type .eq. 2) then ! vr
	   cstr = 'del V gd'
	   read(cstr(1:8), '(4a2)' )(string(i), i = 1, 4)
           write(6,*)'writing del vg'
	   call symbl(xl,yt + 0.5 * csiz, csiz, string, 0.0, 10)
	   yscale = (depth * 0.5) / 13.0
	   call plot(xl,yc,3)
	   call plot(xl + 2.0*csiz, yc, 2)
	   call plot(xr,yc,3)
	   call plot(xr - 2.0*csiz, yc, 2)
           write(6,*)'writing del vg vertical scale'
	   do i = 0, 12
		y = yc + i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		cstr = ' '
		write(cstr(1:2),'(i2)')i
		read(cstr(1:2),'(a2)')string(1)
		y = y - 0.5 * csiz
		call symbl(xl - 3.5 * csiz, y, csiz, string,0.0,2)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,2)
		y = yc - i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		write(cstr(1:3),'(i3)')-i
		read(cstr(1:3),'(2a2)')string(1), string(2)
		y = y - 0.5 * csiz
		call symbl(xl - 3.5 * csiz, y, csiz, string,0.0,3)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,3)
	   end do
	   phi = -180 * deg2rad
	   x = xc + phi * xscale
	   v_fit = A + B1 * sin( phi ) + B2 * cos(phi )
	   y = yc + v_fit * yscale
	   call plot(x, y, 3)
           write(6,*)'plotting vg fit'
	   do i = -179, 180
		phi = i * deg2rad 
		x = xc + phi * xscale
	   	v_fit = A + B1 * sin( phi ) + B2 * cos(phi )
		y = yc + v_fit * yscale
                y = yc
		call plot(x, y, 2)
	   end do
           write(6,*)'plotting vg scatter'
	   do i = 1, npts
		x = xc + phi_n(i) * xscale * deg2rad
		y = yc + vel_n(i) * yscale 
                write(6,*)'i,x,y,phi,vel = ',i,x,y,phi_n(i),vel_n(i)
		call plot(x, y-csiz, 3)
		call plot(x, y+csiz, 2)
		call plot(x-csiz, y, 3)
		call plot(x+csiz, y, 2)
	   end do		
	end if
        write(6,*)'returning'
	return
	end
C ----------------------------
	subroutine cap_titl(flightid, ntasweep, ih, im, is, pitch, 
     +    roll, drift, Cc, D1, D2, Ec, Ac, B1, B2, nrays, npts,
     +	  Vh_mean, alt_mean, tilt_mean, xl, yt, csiz)
C caption
	character flightid*8
	character cstr*40
	integer*2 string(20)
C
	cstr(1:8) = flightid
	cstr(9:20) =' sweep # nnn'
	write(cstr(18:20),'(i3)')ntasweep
	read(cstr(1:20),'(10a2)')(string(i), i = 1,10)
	call symbl(xl, yt, csiz, string, 0.0, 20)
	write(cstr(1:8),'(i2.2,":",i2.2,":",i2.2)')ih,im,is
	read(cstr(1:8),'(4a2)')(string(i), i = 1,4)
	y = yt - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 8)
	cstr(1:26) = 'Fit for nnn rays, nnn pts.'
	write(cstr(9:11),'(i3)')nrays
	write(cstr(19:21),'(i3)')npts
	cstr(1:6) = 'pitch '
	write(cstr(7:11),'(f5.1)')pitch
	read(cstr(1:12),'(6a2)')(string(i), i = 1,6)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 11)
	cstr(1:6) = 'drift '
	write(cstr(7:11),'(f5.1)')drift
	read(cstr(1:12),'(6a2)')(string(i), i = 1,6)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 11)
	cstr(1:5) = 'roll '
	write(cstr(6:10),'(f5.1)')roll
	read(cstr(1:10),'(5a2)')(string(i), i = 1,5)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 10)
C
	cstr(1:22) = 'Veloc residual coeffs:'
	read(cstr(1:22),'(11a2)')(string(i), i = 1,11)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 22)
	cstr(1:24) = 'A = 1234.67 B1 = 1234.67'
	write(cstr(5:11),'(f7.2)')Ac
	write(cstr(18:24),'(f7.2)')B1
	read(cstr(1:24),'(12a2)')(string(i), i = 1,12)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 24)
	cstr(1:12) = 'B2 = 1234.67'
	write(cstr(6:12),'(f7.2)')B2
	read(cstr(1:12),'(6a2)')(string(i), i = 1,6)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 12)
C
	cstr(1:22) = 'Range residual coeffs:'
	read(cstr(1:22),'(11a2)')(string(i), i = 1,11)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 22)
	cstr(1:24) = 'C = 1234.67 D1 = 1234.67'
	write(cstr(5:11),'(f7.2)')Cc
	write(cstr(18:24),'(f7.2)')D1
	read(cstr(1:24),'(12a2)')(string(i), i = 1,12)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 24)
	cstr(1:24) = 'D2 = 1234.67 E = 1234.67'
	write(cstr(5:11),'(f7.2)')D2
	write(cstr(18:24),'(f7.2)')Ec
	read(cstr(1:24),'(12a2)')(string(i), i = 1,12)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 24)
C
	cstr(1:23) = 'Ground speed: nnn.n m/s'
	write(cstr(15:19),'(f5.1)') Vh_mean
	read(cstr(1:24),'(12a2)')(string(i), i = 1,12)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 23)
	cstr(1:19) = 'altitude: nnnn.n km'
	write(cstr(11:16),'(f6.1)') alt_mean
	read(cstr(1:20),'(10a2)')(string(i), i = 1,10)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 19)
	cstr(1:16) ='Mean tilt: nnn.n'
	write(cstr(12:16),'(f5.1)')tilt_mean
	read(cstr(1:16),'(8a2)')(string(i), i = 1,8)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 16)
	return
	end
C ------
	subroutine time_splat(nswps, iswp1, resid_Vg, resid_Rg, 
     +		tilt_cor, plot_type, xl, yb, width, 
     +		depth, csiz)
 	real resid_Vg(nswps), resid_Rg(nswps), tilt_cor(nswps)
	integer plot_type
	character cstr*10
	integer*2 string(5)
C
	call newpn(4)
	xr = xl + width
	yt = yb + depth
	xc = xl + width * 0.5
	yc = yb + depth * 0.5
	deg2rad = acos(-1.0)/180.0
	xscale = width / (nswps - iswp1)
	cstr(1:4) = 'Swp # ' 
	read(cstr(1:6),'(3a2)')(string(i), i = 1,3)
	x1 = xl + 0.5* width - 2.5 * csiz
	call symbl(x1,yb - 3.0 * csiz, csiz, string,0.0,6)
	do i = iswp1, nswps, 5
		x1 = xl + ( i - iswp1 ) * xscale
		call plot(x1,yb,3)
		call plot(x1, yb + csiz, 2)
		if( mod(i,25).eq.0)then
		  call plot(x1,yb,3)
		  call plot(x1, yb + 1.5 *csiz, 2)
		  cstr = ' '
		  write(cstr(1:3),'(i3)')i
		  read(cstr(1:4),'(2a2)')string(1), string(2)
		  x1 = x1 - 1.5 * csiz
		  call symbl(x1,yb - 1.5 * csiz, csiz, string,0.0,3)
		end if
	end do
	call plot(xl, yb, 3)
	call plot(xl, yt, 2)
	call plot(xr, yt, 2)
	call plot(xr, yb, 2)
	call plot(xl, yb, 2)
	if(plot_type .eq. 1) then ! range
	   cstr = 'del range '
	   read(cstr(1:10), '(5a2)' )(string(i), i = 1, 5)
	   call symbl(xl,yt + 0.5 * csiz, csiz, string, 0.0, 10)
	   yscale = (depth*0.5) / 4000.0
	   do i = 0, 4000, 500
		y = yc + i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		cstr = ' '
		write(cstr(1:4),'(i4)')i
		read(cstr(1:4),'(2a2)')string(1), string(2)
		y = y - 0.5 * csiz
		call symbl(xl - 4.5 * csiz, y, csiz, string,0.0,4)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,4)
		y = yc - i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		write(cstr(1:5),'(i5)')-i
		read(cstr(1:5),'(3a2)')string(1), string(2), string(3)
		y = y - 0.5 * csiz
		call symbl(xl - 5.5 * csiz, y, csiz, string,0.0,5)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,5)
	   end do
	   x = xl + xscale
	   y = yc + resid_Rg(iswp1) * yscale
	   call plot(x, y, 3)
	   do i = iswp1+1, nswps
		x = xl + (i - iswp1) * xscale
		y = yc + resid_Rg(i) * yscale
		call plot(x, y, 2)
	   end do
	else if(plot_type .eq. 2) then ! vr
	   cstr = 'del V gd'
	   read(cstr(1:8), '(4a2)' )(string(i), i = 1, 4)
	   call symbl(xl,yt + 0.5 * csiz, csiz, string, 0.0, 8)
	   yscale = (depth * 0.5) / 13.0
	   call plot(xl,yc,3)
	   call plot(xl + 2.0*csiz, yc, 2)
	   call plot(xr,yc,3)
	   call plot(xr - 2.0*csiz, yc, 2)
	   do i = 0, 12
		y = yc + i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		cstr = ' '
		write(cstr(1:2),'(i2)')i
		read(cstr(1:2),'(a2)')string(1)
		y = y - 0.5 * csiz
		call symbl(xl - 3.5 * csiz, y, csiz, string,0.0,2)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,2)
		y = yc - i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		write(cstr(1:3),'(i3)')-i
		read(cstr(1:3),'(2a2)')string(1), string(2)
		y = y - 0.5 * csiz
		call symbl(xl - 3.5 * csiz, y, csiz, string,0.0,3)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,3)
	   end do
	   x = xl + xscale
	   y = yc + resid_Vg(iswp1) * yscale
	   call plot(x, y, 3)
	   do i = iswp1+1, nswps
		x = xl + (i-iswp1) * xscale
		y = yc + resid_Vg(i) * yscale
		call plot(x, y, 2)
	   end do
	else if(plot_type .eq. 3) then ! tilt correction
	   cstr = 'tilt cor'
	   read(cstr(1:8), '(4a2)' )(string(i), i = 1, 4)
	   call symbl(xl,yt + 0.5 * csiz, csiz, string, 0.0, 8)
	   yscale = (depth * 0.5) / 5.0
	   call plot(xl,yc,3)
	   call plot(xl + 2.0*csiz, yc, 2)
	   call plot(xr,yc,3)
	   call plot(xr - 2.0*csiz, yc, 2)
	   do i = 0, 5.0
		y = yc + i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		cstr = ' '
		write(cstr(1:2),'(i2)')i
		read(cstr(1:2),'(a2)')string(1)
		y = y - 0.5 * csiz
		call symbl(xl - 3.5 * csiz, y, csiz, string,0.0,2)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,2)
		y = yc - i * yscale
		call plot(xl,y,3)
		call plot(xl + csiz, y, 2)
		call plot(xr,y,3)
		call plot(xr - csiz, y, 2)
		write(cstr(1:3),'(i3)')-i
		read(cstr(1:3),'(2a2)')string(1), string(2)
		y = y - 0.5 * csiz
		call symbl(xl - 3.5 * csiz, y, csiz, string,0.0,3)
		call symbl(xr + 0.5 * csiz, y, csiz, string,0.0,3)
	   end do
	   x = xl + xscale
	   y = yc + tilt_cor(iswp1) * yscale
	   
	   call plot(x, y, 3)
	   do i = iswp1+1, nswps
		x = xl + (i-iswp1) * xscale
		y = yc + tilt_cor(i) * yscale
		call plot(x, y, 2)
	   end do
	end if
	call newpn(4) ! restore
        pause
	return
	end
C --
	subroutine cap_time(flightid, ntasweep, ihs, ims, ihe, ime,
     +		  nsweeps, xl, yt, csiz)
C caption for time series plot
	character flightid*8
	character cstr*40
	integer*2 string(20)
C
	cstr(1:8) = flightid
	cstr(9:19) =' nnn sweeps'
	write(cstr(10:12),'(i3)')nsweeps
	read(cstr(1:20),'(10a2)')(string(i), i = 1,10)
	call symbl(xl, yt, csiz, string, 0.0, 19)
C
	write(cstr(1:14),'(i2.2,":",i2.2," to ",
     +		i2.2,":",i2.2)')ihs,ims,ihe,ime
	read(cstr(1:14),'(7a2)')(string(i), i = 1,7)
	y = yt - 1.5 * csiz
	call symbl(xl, y, csiz, string, 0.0, 14 )
	return
	end
C --------------------------------------------------------
	subroutine chk_att_ang(pitch,drift,roll,ier)
C old tapes (and maybe new) occasionally have bad nav angles
	real pitch, drift, roll
	integer ier
	real dev_p, dev_d, dev_r
	parameter( dev_p = 15.0, dev_d = 60.0, dev_r = 45.0 )
C
	if( abs(pitch) .gt. dev_p) ier = -1
	if( abs(drift) .gt. dev_d) ier = -1
	if( abs(roll) .gt. dev_r) ier = -1
	return	
	end

