	Program random_pick_so
C------------------------------------------------------------------------------
C  Choose some SOs randomly.
C  Raw SO file is like: KHGX_20070912090000_so
C  select 1/10 data as verification data, and save as KHGX_20070912090000_so_ver;
C  the other 9/10 data will be the assimilation data and saved as KHGX_20070912090000_so_ass in the random order.
C------------------------------------------------------------------------------
	implicit none
        CHARACTER CHARDATE*8,CHARTIME*10,CHARZONE*5
        INTEGER TIMEVALUES(8),IJI
	character*80 filename
	real so(100000,12)
	real temp(12)
	integer timec(100000,5)
	integer so_num, so_number
	real, allocatable, dimension(:)::scatter
	integer, allocatable, dimension(:)::iscatter
	integer external iargc
	integer iost, i, index, j, i10, ilength 
	i10 =2   !1/10 as verrification data
C----------------------------------------------------------------
C Get argc
	if (iargc() .lt. 1) then
	   write(6,*) ' usage: random_pick_so filename(0508271500_20m) '
	   stop
	else
	   call getarg(1, filename)
	endif

	ilength=len_trim(filename)
	write(*,*)ilength
C----------------------------------------------------------------
C get so data
	open(10, file=filename(1:ilength)//'.so', status = 'old', 
     1       form = 'formatted', iostat = iost )
	if( iost < 0 ) then
          write(6,*)'cannot open file: '//filename(1:ilength)//'.so'
          stop
	endif
	open(21, file=filename(1:ilength)//'.so_ver')
	open(22, file=filename(1:ilength)//'.so_ass')
	so_num = 1
        write(6,*)'one'
	do_get_so_data_loop : do
	   read(10, '(i4,4i2,12f12.3 )', iostat = iost )
     1          timec(so_num,1:5), so(so_num,1:12)
	   if( iost < 0 ) exit
	   so_num = so_num + 1
c           write(6,*)'so_num = ',so_num
	end do do_get_so_data_loop
        write(6,*)'two'
	so_num = so_num - 1
C----------------------------------------------------------------
C generate random number from 1-->so_num
        so_number=so_num
	allocate( scatter  (so_number))
	allocate(iscatter  (so_number))
	call random_seed
	call random_number(scatter)
        write(6,*)'three'
	do i = 1, so_num
	   index=minloc(scatter, dim=1)
	   iscatter(i) = index
	   scatter(index) = 2.0
	enddo
	write(*,*)iscatter(1:10)
        write(6,*)'four'
C----------------------------------------------------------------
C output
	index = so_num/i10
	do i = 1, index
	   j = iscatter(i)
	   write(21, '(i4,4i2.2,12f10.3)')timec(j,1:5), so(j,1:12)
	enddo
	close(21)
	do i = index+1, so_num
	   j = iscatter(i)
	   write(22, '(i4,4i2.2,12f10.3)')timec(j,1:5), so(j,1:12)
	enddo
	close(22)
	deallocate( scatter )
	deallocate(iscatter )
C----------------------------------------------------------------
        open(72,file='../../lastsweep.txt')
        CALL DATE_AND_TIME(CHARDATE,CHARTIME,CHARZONE,TIMEVALUES)
        WRITE(72,72727)(TIMEVALUES(IJI),IJI=5,7),CHARDATE
        WRITE(6,72727)(TIMEVALUES(IJI),IJI=5,7),CHARDATE
72727   FORMAT('PROCESSING COMPLETE AT ',3I2.2,' on ',A)
        WRITE(6,72728)TIMEC(1,1:5),TIMEC(SO_NUM,1:5)
        WRITE(72,72728)TIMEC(1,1:5),TIMEC(SO_NUM,1:5)
72728	FORMAT(I4,2I2.2,X,2I2.2,' at ',I4,2I2.2,X,2I2.2)
        CLOSE(72)
	end
