      PROGRAM READ_SUB_FILE
      CHARACTER*132 FILENAME,OUTFILENAME
      REAL OUTTIME(800),PAZM(800),VEL(1000000),DBZ(1000000)
      CALL GETARG(1,FILENAME)
      CALL GETARG(2,OUTFILENAME)
      OPEN(80,FILE=FILENAME,FORM='UNFORMATTED')
      READ(80)NUM_RAYS,NBINS,MAX_HRD_DIM
      WRITE(6,*)'NUM_RAYS = ',NUM_RAYS
      WRITE(6,*)'NBINS = ',NBINS
      WRITE(6,*)'MAX_HRD_DIM = ',MAX_HRD_DIM
      CALL FILECHECK(OUTTIME,PAZM,VEL,DBZ,NUM_RAYS,NBINS,OUTFILENAME)
      CLOSE(80)
      STOP
      END
      SUBROUTINE FILECHECK(OUTTIME,AZIMUTH,VEL,DBZ,NUM_RAYS,NBINS,
     + OUTFILENAME)
      USE NETCDF
      CHARACTER OUTFILENAME*132
      REAL OUTTIME(NUM_RAYS),AZIMUTH(NUM_RAYS)
      REAL VEL(NUM_RAYS,NBINS),DBZ(NUM_RAYS,NBINS)
      REAL VALID_RANGE_DBZ(2),VALID_RANGE(2),VALID_MIN_DBZ,VALID_MAX_DBZ
      REAL VALID_MIN,VALID_MAX,DFLAG
      INTEGER RAYNUMBERS(800)
      INTEGER BINNUMBERS(2048)
      INTEGER NCID,ISTAT
      INTEGER IRAYDIMID,IRADDIMID,IDIMIDS(2),ITVARID,IRADVARID
      INTEGER IRAYVARID,IAZIVARID
      INTEGER IDBZVARID,IVELVARID
      INTEGER ISTART(2),ICOUNT(2)
      READ(80)AZIMUTH
      READ(80)OUTTIME
      READ(80)VEL
      READ(80)DBZ
      RDFLAG=-32.
      RVFLAG=-999.9
      VALID_RANGE_DBZ(1)=-31.9
      VALID_RANGE_DBZ(2)=70.
      VALID_RANGE(1)=-800.
      VALID_RANGE(2)=800.
      VALID_MIN_DBZ=-31.9
      VALID_MAX_DBZ=70.
      VALID_MIN=-800.
      VALID_MAX=800.
      DO I=1,NUM_RAYS
         RAYNUMBERS(I)=I-1
      ENDDO
      DO I=1,NBINS
         BINNUMBERS(I)=I-1
      ENDDO
c      DO I=1,NUM_RAYS
c         DO J=1,NBINS
c            VEL(I,J)=20.
c            DBZ(I,J)=20.
c         ENDDO
c      ENDDO
      WRITE(6,*)'NETCDF FILE IS NAMED',OUTFILENAME
c      PAUSE
      ISTAT=NF90_CREATE(OUTFILENAME,NF90_CLASSIC_MODEL,NCID)
      ISTAT=NF90_DEF_DIM(NCID,"raynumber",NUM_RAYS,IRAYDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"binnumber",NBINS,IRADDIMID)
      IDIMIDS(1)=IRAYDIMID
      IDIMIDS(2)=IRADDIMID
      ISTAT=NF90_DEF_VAR(NCID,"time",
     +     NF90_FLOAT,IRAYDIMID,ITVARID)
      ISTAT=NF90_DEF_VAR(NCID,"binnumber",
     +     NF90_INT,IRADDIMID,IRADVARID)
      ISTAT=NF90_DEF_VAR(NCID,"raynumber",
     +     NF90_INT,IRAYDIMID,IRAYVARID)
      ISTAT=NF90_DEF_VAR(NCID,"azimuth",
     +     NF90_FLOAT,IRAYDIMID,IAZIVARID)
      ISTAT=NF90_DEF_VAR(NCID,"reflectivity",NF90_FLOAT,
     + IDIMIDS,IDBZVARID)
      ISTAT=NF90_DEF_VAR(NCID,"velocity",NF90_FLOAT,
     +     IDIMIDS,IVELVARID)
      DFLAG=-999.9
      ISTAT=NF90_PUT_ATT(NCID,IAZIVARID,'UNITS','degrees')
      ISTAT=NF90_PUT_ATT(NCID,ITVARID,'UNITS','seconds_past_midnight')
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'UNITS','dBZ')
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,"valid_range",VALID_RANGE_DBZ)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,"valid_min",VALID_MIN_DBZ)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,"valid_max",VALID_MAX_DBZ)
      ISTAT=NF90_PUT_ATT(NCID,IVELVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IVELVARID,"valid_range",VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IVELVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IVELVARID,"valid_min",VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IVELVARID,"valid_max",VALID_MAX)
      ISTAT=NF90_ENDDEF(NCID)
      ISTART(1)=1
      ICOUNT(1)=NUM_RAYS
      ISTAT=NF90_PUT_VAR(NCID,IRAYVARID,RAYNUMBERS,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IAZIVARID,AZIMUTH,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,ITVARID,OUTTIME,ISTART,ICOUNT)
      ISTART(1)=1
      ICOUNT(1)=NBINS
      ISTAT=NF90_PUT_VAR(NCID,IRADVARID,BINNUMBERS,ISTART,ICOUNT)
      ISTART(1)=1
      ISTART(2)=1
      ICOUNT(1)=NUM_RAYS
      ICOUNT(2)=NBINS
      DO I=1,NUM_RAYS
         WRITE(6,*)'NETCDF NUM_RAY,AZIMUTH,OUTTIME = '
     +        ,I,AZIMUTH(I),OUTTIME(I)
         WRITE(6,*)'NETCDF VEL'
         WRITE(6,'(10F8.2)')(VEL(I,J),J=1,NBINS)
         WRITE(6,*)'NETCDF DBZ'
         WRITE(6,'(10F8.2)')(DBZ(I,J),J=1,NBINS)
      ENDDO
      WRITE(6,*)'BEFORE PUTTING VEL'
c      PAUSE
      ISTAT=NF90_PUT_VAR(NCID,IVELVARID,VEL,ISTART,ICOUNT)
      WRITE(6,*)'BEFORE PUTTING DBZ'
c      PAUSE
      ISTAT=NF90_PUT_VAR(NCID,IDBZVARID,DBZ,ISTART,ICOUNT)
      WRITE(6,*)'BEFORE CLOSING NETCDF FILE'
c      PAUSE
      ISTAT=NF90_CLOSE(NCID)
      WRITE(6,*)'AFTER CLOSING NETCDF FILE'
c      PAUSE
      RETURN
      END
