C ------------
	subroutine mjd_to_cal( mjday, year, month, day)
C Calculate year month and day  given modified Julian
C day referenced to 1-1-1970.
C modified algorithm from Practical Astronomy with Your Pocket 
C Calculator, 3rd ed, by Peter Duffet-Smith. 
	integer*4 mjday, year, month, day
C constants to convert from mod to true julian day:
	iref_yr = 1970
	iref_mo = 1
	iref_da = 1
	call true_julday(iref_yr,iref_mo,iref_da,0,0,0.0,tjday)
	tjday = tjday + mjday -1 ! not sure why i have to subtract 1
C
	tjday = tjday + 0.5
	i = int( tjday )
	f = tjday - i
	a = int( (i - 1867216.25) / 36524.25 )
	b = i + 1 + a - int( a * 0.25 )
	c = b + 1524
	d = int( (c - 122.1) / 365.25 )
	e = int( 365.25 * d )
	g = int( (c - e) / 30.6001 )
	day = c - e + f - int(30.6001 * g)
	if( g .lt. 13.5) then
		month = g -1
	else
		month = g - 13
	end if
	if( month .gt. 2.5 ) then
		year = d - 4716
	else
		year = d - 4715
	end if
	return
	end
C ------------
	subroutine true_julday(year,month,day,hr,min,sec,date_jul)
C convert date to Julian Day relative to noon GMT 1 Jan 4713 BC.
C Algorithm from Practical Astronomy with Your Pocket Calculator, 3rd ed,
C by Peter Duffet-Smith.
	integer year, month, day, hr, min
	real sec ! so can have fractions of a sceond
	integer A, B, C, D
	real date_jul
C
	date = day + hr/24.0 + min / 1440.0 + sec / 86400.0
	if( month .le. 2 )then
		mo = month + 12
		yr = year - 1
	else
		mo = month
		yr = year
	end if
	B = 0
	if( year.gt.1583)then ! always the case for me
		A = int(yr / 100)
		B = 2 - A + int(A / 4)
	else if ( year .eq. 1582) then ! fine tune to beg of Gregorian cal
		if( (month .gt. 10) .or. 
     +		    ( (month .eq. 10).and.(day.ge.15) ) )then
			A = int(yr / 100)
			B = 2 - A + int(A / 4)
		end if
	end if
	if( yr .lt. 0)then
		C = int( (365.25 * yr) - 0.75)
	else
		C = int(365.25 * yr)
	end if
	D = int( 30.6001 * (mo + 1.0) )
	date_jul = B + C + D + date + 1720994.5
	return
	end
C ----------
	subroutine cal_to_mjd( year, month, day, mjday)
C Calculate modified Julian day referenced to 1-1-1970, 
C given year month and day.
C modified algorithm from Practical Astronomy with Your Pocket 
C Calculator, 3rd ed, by Peter Duffet-Smith. 
	integer*4 mjday, year, month, day
C constants to convert from mod to true julian day:
	iref_yr = 1970
	iref_mo = 1
	iref_da = 1
C reference day
	call true_julday(iref_yr,iref_mo,iref_da,0,0,0.0,tjrefday)
C desired date, in true Julian days
	call true_julday(year, month, day, 0, 0, 0.0, tjday)
C Modified Julian day
	mjday = tjday - tjrefday + 1 ! add one for inverse....
	return
	end


