C These routines are used to selext thich
C data are retunded by calls to radar_rvp8_read or
C read_iris_tdr_ray. Needed because these two subs
C only return 3 arrays, numinally dBZ, Doppler and
C spectral width. RVP8 can write out different data thpes
C and this is a way to analyze and displany these
C other variables. 27 March 2012 Peter dodge
C
	subroutine set_data_flags( error_flag )
C
	implicit none
	integer error_flag
	common /rvp8_data_flags/data_sel_flags,
     +		num_data_types, sweep_data_types
	integer*4 data_sel_flags(3)
	integer*4 num_data_types, sweep_data_types(10)
	integer i, imatch
	integer idBZ_type, iDop_type, iwid_type
C
	error_flag = 1 ! success
	if((num_data_types.le.0).or.
     +	  (num_data_types.gt.10))then
		error_flag = -1
	  	write(6,*)num_data_types,'Bad # data types. read a ray!'
		return
	end if
C show available data types
	write(6,*)'available data types:'
	do i = 1, num_data_types
	  call show_dsp_db_type(6,sweep_data_types(i))
	end do

C pick types
10	write(6,*)'Enter type for dBZ array:'
	read(5,*)idbz_type
	imatch = 0
	do i = 1, num_data_types
	   if(sweep_data_types(i).eq.idBZ_type)imatch = 1
	end do
	if(imatch .eq. 1) then
	  data_sel_flags(1) = idBZ_type
	else
	  write(6,*)idBZ_type,' no good.'
	  go to 10
	end if
C
20	write(6,*)'Enter type for Doppler array:'
	read(5,*)idop_type
	imatch = 0
	do i = 1, num_data_types
	   if(sweep_data_types(i).eq.iDop_type)imatch = 1
	end do
	if(imatch .eq. 1) then
	  data_sel_flags(2) = iDop_type
	else
	  write(6,*)iDop_type,' no good.'
	  go to 20
	end if
30	write(6,*)'Enter type for spectral width array:'
	read(5,*)iwid_type
	imatch = 0
	do i = 1, num_data_types
	   if(sweep_data_types(i).eq.iwid_type)imatch = 1
	end do
	if(imatch .eq. 1) then
	  data_sel_flags(3) = iwid_type
	else
	  write(6,*)iwid_type,' no good.'
	  go to 30
	end if

C
	return
	end
C =============================
	subroutine show_data_flags(lu, error_flag )
	integer error_flag, lu
	common /rvp8_data_flags/data_sel_flags,
     +		num_data_types, sweep_data_types
	integer*4 data_sel_flags(3)
	integer*4 num_data_types, sweep_data_types(10)
	integer i

C
	error_flag = 1 ! success
	if((num_data_types.le.0).or.
     +	  (num_data_types.gt.10))then
		error_flag = -1
	  	write(6,*)num_data_types,'Bad # data types. read a ray!'
		return
	end if
C show available data types
	write(6,*)'available data types:'
	do i = 1, num_data_types
	  call show_dsp_db_type(6,sweep_data_types(i))
	end do
C
	write(lu,*)'dBZ variable:'
	call show_dsp_db_type(lu,data_sel_flags(1))
	write(lu,*)'Doppler variable:'
	call show_dsp_db_type(lu,data_sel_flags(2))
	write(lu,*)'spectal width variable:'
	call show_dsp_db_type(lu,data_sel_flags(3))
C
	return
	end
