	subroutine set_up_sweep_arrays
     +    (lu, lu_errors, ierr)
C this does not open individula rvp8 files, rather it 
C opens a list of those files, su radar_rvp8_read
C and rvp8_search can fine correct weep to open.
C
C	directory (sharacter): path to sweep files directory
C	lu = logical unit number for file list file
C	lu_errors(it): logical unit for error messages
C	ierr *integera): error status
C		= p meand no errors
C		= -1  means list file is empty
C		>0 open error number fron fortran

	implicit none

c	character directory*(*)
	integer*4 lu, lu_errors, ierr
C need HRD common blocks to set sweep counters
	include "hrd_radar_common_blocks.f"
 
C Hide first sweep name here, so you
C so not have to call rvp8_search to prime the pump.
	common /rvp8_files/sweep_open,
     +		current_fptr,
     +		current_fn
	logical*8 sweep_open
C 64 bit machines have 8 byte pointers
	integer*8 current_fptr
	character*132 current_fn, sweep_fn
	character command*132
	integer ibeg,iend,nc,i
	integer year,day
	character skip_string*8

C header flags:
	integer*4 nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag
C added a common to pass data type flags. These are used
C to determine which data type gets written in eacd array.
C in this subtoutine we set defaults...these can be changed
C after calling this subroutine.
	include "sigmet_dsp_data_types_f90.h"
	common /rvp8_data_flags/data_sel_flags,
     +		num_data_types, sweep_data_types
	integer*4 data_sel_flags(3)
	integer*4 num_data_types, sweep_data_types(10)

C More stuff, to deal with midnight crossing
C and whether or not to use 48 h clock...
C in this routine , set crossed_midnight false and
C flight_jday to date of first file. then user
C can reset if she knows filightid is less ghtn currect day...
C
	COMMON /midnight/crossed_midnight,flight_jday
	integer*4 jday, flight_jday
	logical*8 crossed_midnight

C data type defaults:
c spectral width
c	data_sel_flags(1) = DB_WIDTH2
c spectral width
c normal
	data_sel_flags(1) = DB_DBZ2
c normal
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_SQI2
C set num data types to zero until we have
C actually read a file to know what is in the rays.
	num_data_types = 0
	do i = 1, 10
	  sweep_data_types(i) = -1
	end do
C
C initialize sweep cointers in hrd common blocks
C set to zero because will be incremented
C in radar_rvp8_read
	nlfsweep = 0
	ntasweep = 0
c added stuff here to set flags that determin whick
C extended headers values are used to load HRD common
C blocks.  17 Aug 2011
C For each flaf,
C	1: use inertial values ( airs )
C	2: use GPS values
C	3: use AAMPS values
C
	nav_flag = 2
	alt_flag = 2
c***I think attitude_flag should normally be set to 1
	attitude_flag = 1
	gdspd_flag = 1
c***************************************************
	wind_flag = 3

	call set_hdr_flags(nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag)
	return
	end
