	subroutine show_iz(ixl, iyb, iz, max_x, max_y,imax,jmax,
     +        zmin,zmax, data_type, too_noisy, ambiguous,
     +		im_struct, display_label,chartimemin,chartimemax,
     +          charaftfore)
C convert dBZ or Doppler to 0-15, show on X window
C
C ixl,iyb moves the lower left corner to pixel (ixl,iyb)
C
C iz is the integer value to plot at each location in the 2D array
C
	integer*2 iz(max_x, max_y)
	integer data_type
C
C im_struct passes information from one TV c program to another
C       it originally comes from opening the raster window in calling
C       program
C 
	integer im_struct(100)
C
	character*32 display_label
C
C CHARTIMEMIN AND CHARTIMEMAX ARE 6 DIGIT TIMES FOR BEGINNING AND END OF
C       RADAR SWEEP
C CHARAFTFORE CONTAIN EITHER THE WORD FORE OR AFT TO INDICATE WHICH TYPE
c       IS BEING DISPLAYED
C
        character*6 chartime,chartimemin,chartimemax
        character*5 charaftfore
	parameter( iras_max = 900, jras_max = 350)
	integer*4 raster(iras_max, jras_max)
C
c        write(6,*)'entered show_iz'
	do j = 1, 10
		do i = 1, iras_max
			raster(i, j)=0+(i*16/iras_max)
c                        write(6,*)'i,j,raster = ',i,j,raster(i,j)
		end do
	end do
	do j = 11, jras_max
		do i = 1, iras_max
			raster(i, j) = 0
		end do
	end do
C
c        write(6,*)'show_iz spot 1'
C
C ICOL = 0 IS BLACK, ICOL = 15 IS WHITE, ICOL = 1 WAS USED AT SOME POINT TO
C       INDICATE AMBIGUOUS VELOCITY
C       COLORS 2-13 WILL BE USED TO DISPLAY DATA
C       COLOR 14 WILL INDICATE THAT YOU ARE OVER THE VALUE DISPLAYED THERE
C       COLOR 7/8 BOUNDARY INDICATES THE HALFWAY POINT IN THE CHOSEN SCALE
C 
	if( data_type .eq. 1) then ! dBZ
	  zscale = 12.0 / (zmax - zmin) ! for colors 2-14
	  do j = 1, jmax
	   do i = 1, imax
	    ival = iz(i, j)
	    if( ival .eq. -9999)then ! missing, set to 0
		icol = 0
	    else
		val = ival * 0.1
		if(val .lt. zmin)then
			icol = 1
		else if(val .gt. zmax)then
			icol = 14
		else
			icol = 2 + (val-zmin) * zscale
		end if
	    end if
	    raster(ixl + i, iyb + j)  = icol
	   end do
	  end do
	else if( data_type .eq. 2) then
		zscale = 12.0 / (zmax - zmin) ! for colors 2-14
		do j = 1, jmax
		    do i = 1, imax
		    	ival = iz(i, j)
			val = ival * 0.1
C in main too_noisy = -200.0, bad-val = -999.9, so this takes care of both:
			if(val .le. too_noisy)then
				icol = 0
C ambiguous = -100.0
			else if(val .le. ambiguous)then
				icol = 1
			else if(val .lt. zmin)then
				icol = 0
			else if(val .gt. zmax)then
				icol = 14
			else
				icol = 2 + (val-zmin) * zscale
			end if
                        IAX=IXL+I
                        IAY=IYB+J
c        write(6,*)'show_iz spot 2'
c                        WRITE(6,*)'IAX,IAY = ',IAX,IAY
       	if(iax.gt.0.and.iay.gt.0.and.iax.le.iras_max.and.
     +     iay.le.jras_max)raster(ixl + i, iyb + j)  = icol
c                        write(6,*)'ixl +i, iyb +j = ',ixl +i,iyb +j
c       	                raster(ixl + i, iyb + j)  = icol
		    end do
	  end do
	end if
c        write(6,*)'calling rasx_display_image'
c        write(6,*)'iras_max = ',iras_max
c        write(6,'(A32)')display_label
        call rasx_display_image(iras_max, raster, im_struct,
     +		display_label)
c        write(6,*)'returned from rasx_display_image'
C and outline area:
	call x_tvline(ixl, iyb, ixl + imax, iyb, 15,im_struct)
	call x_tvline(ixl+imax, iyb, ixl + imax, iyb+jmax, 15,im_struct)
	call x_tvline(ixl, iyb+jmax, ixl + imax, iyb+jmax, 15,im_struct)
	call x_tvline(ixl, iyb, ixl, iyb + jmax, 15,im_struct)
        call color_bar(data_type,ixl,iyb,zmin,zmax,ambiguous,
     +   im_struct,chartimemin,chartimemax,charaftfore)       
c        write(6,*)'leaving show_iz'
	return
	end
C --------------------------------------
      subroutine cap_solo(ixl, iyt, imax, jmax, rad_name, radar_id,
     +	project, avg_el, time, mon, day, yr, sx, sy, icol,
     +	data_type, im_struct)
C 
C IT APPEARS THIS IS NOT USED BY THE AUTOMATED SOFTWARE GRAPHICS--JOHN GAMACHE
C
C Text captions 
      parameter(ispac = 20)
	integer*4 im_struct(47)
      integer mon,day,yr
	integer data_type
      character string*21,rad_name*8, project*20,radar_id*4
      character*3 chmon(12)
      save chmon
      data chmon/'Jan','Feb','Mar','Apr','May','Jun','Jul', 
     +        'Aug','Sep','Oct','Nov','Dec'/
      ifont = 1 
       call x_tvtype(ixl,iyt-6*ispac,project,20,ifont,icol,im_struct) 
c date: 
	if( ( mon.ge. 1) .and. ( mon .le. 12 ) )then
	        string(1:3)=chmon(mon)
        	write(string(4:7),'(". ",i2)')day 
		if(yr.lt.1900) yr = yr + 1900
	        write(string(8:13),'(", ",i4)')yr 
	        call x_tvtype(ixl,iyt-ispac,string,13,ifont,
     +			icol,im_struct) 
		call ctme(time,ih,im,is)
		string(1:12)='nn:nn:nn UTC'
		write(string(1:8),'(i2,":",i2.2,":",i2.2)')ih,im,is
	        call x_tvtype(ixl,iyt-2*ispac,string,12,ifont,
     +			icol,im_struct) 
	end if
C domain:
	iwide=imax*sx 
	itall=jmax*sy 
	write(string(1:3),'(i3)')iwide 
	write(string(7:9),'(i3)')itall
	string(4:6)=' x ' 
	string(10:12)=' km' 
	call x_tvtype(ixl,iyt-4*ispac,string,12,ifont,icol,im_struct)
C elevations:
	string(1:11) = 'El nn.n deg'
	write(string(4:7),'(f4.1)')avg_el
        call x_tvtype(ixl,iyt-3*ispac, string, 11, ifont,
     +		icol,im_struct)
c Site ID
	call x_tvtype(ixl,iyt-5*ispac,rad_name,8,ifont,icol,im_struct) 
c where it is:
C	call x_tvtype(ixl,iyt-5*ispac,radnam,10,ifont,icol,im_struct) 
C
	return
	end
C -----
	subroutine color_bar(itype, ixl, iyb, zmin, zmax, nyq_vel,
     +		im_struct,chartimemin,chartimemax,charaftfore)
	character string*21, chdb*8, chartimemax*6, chartimemin*6
        character charaftfore*5
	real zmin, zmax, nyq_vel
	integer*4 im_struct(47)
C
	ixbl = ixl
        ixbl2 = ixbl +750
	iybb = iyb
	iht = 20
	ixbr = ixl + iht + 750
	icol = 16
        ixtime=400
        iytime=300
c        write(6,*)'chartimemin,chartimemax = ',chartimemin,chartimemax
        write(string,6767)chartimemin,chartimemax,charaftfore
 6767	format(a6,' - ',a6,a5)
        call x_tvtype(ixtime,iytime,string,20,1,icol,im_struct)
 	if( itype .eq. 1 ) then 
C Dbz:
	iybb = iyb - 2*iht
        scaling = ( zmax - zmin )/12.0
        do i = 2, 14 
          call x_tvfrec(ixbl2+1, (iybb+i*iht)+1, ixbr-1,
     +		(iybb+(i+1)*iht), i, im_struct)
	  idbz1=((i-2)*scaling)+zmin ! low dbz 
	  idbz2=((i-1)*scaling)+zmin ! high dbz 
	  idbzm = idbz1 + (idbz2-idbz1)*0.5
	  write(chdb(1:3),'(i3)')idbz1
	  if((i .eq.2).or.(i.eq.14)) then
		write(chdb(4:7),'(a4)')' dBZ'
		call x_tvtype(ixbr+1,(iybb+i*iht)+2,chdb,7,1,
     +			icol, im_struct)
	  else
		call x_tvtype(ixbr+1,(iybb+i*iht)+2,chdb,3,1,
     +			icol, im_struct)
	  end if
         end do
C
	else if( itype .ge. 2) then
C Doppler
	iybb = iyb - iht
        scaling = ( zmax - zmin )/12.0
	 i = 1
	 call x_tvfrec(ixbl2+1, (iybb+i*iht)+1, ixbr-1,
     +		(iybb+(i+1)*iht), i, im_struct)
c	 string = 'Range Ambiguous'
c	 call x_tvtype(ixbr+1, (iybb+i*iht)+2, string, 15, 1,
c     +		icol, im_struct)
	 do i = 2, 14 
	  call x_tvfrec(ixbl2+1, (iybb+i*iht)+1, ixbr-1,
     +		(iybb+(i+1)*iht), i, im_struct)
	  idbz1=((i-2)*scaling)+zmin ! low vel 
	  idbz2=((i-1)*scaling)+zmin ! high vel 
	  idbzm = idbz1 + (idbz2-idbz1)*0.5
	  write(chdb(1:3),'(i3)')idbz1
	  if( (i .eq.2).or.(i.eq.14) ) then
	    write(chdb(4:7),'(a4)')' m/s'
	    call x_tvtype(ixbr+1, (iybb+i*iht)+2, chdb, 7, 1,
     +		icol, im_struct)
	  else
	  call x_tvtype(ixbr+1, (iybb+i*iht)+2, chdb, 3, 1,
     +		icol, im_struct)
	  end if
	 end do
	 string = 'Nyquist vel nn.nn m/s'
	 write(string(13:17),'(f5.2)')nyq_vel
         call x_tvtype(ixbl-50,iybb-20,string,21,1,icol,
     +		im_struct) 
C
	end if
	return
	end 
